=== modified file 'NEWS'
--- NEWS	2010-05-06 07:48:22 +0000
+++ NEWS	2010-04-26 23:36:26 +0000
@@ -16,10 +16,6 @@
 New Features
 ************
 
-* ``bzr commit`` accepts ``-p`` (for "patch") as a shorter name for
-  ``--show-diff``.
-  (Parth Malwankar, #571467)
-  
 * ``bzr ignore`` now supports a ``--default-rules`` option that displays
   the default ignore rules used by bzr. The flag ``--old-default-rules``
   is no longer supported by ``ignore``.
@@ -38,35 +34,19 @@
   better with sudo.
   (Martin <gzlist@googlemail.com>, Parth Malwankar, #376388)
 
-* ``bzr log --exclude-common-ancestry -r X..Y`` displays the revisions that
-  are part of Y ancestry but not part of X ancestry (aka the graph
-  difference).
-  (Vincent Ladeuil, #320119)
-
 * ``bzr selftest --parallel=fork`` wait for its children avoiding zombies.
   (Vincent Ladeuil, #566670)
 
 * ``bzr selftest`` should not use ui.note() since it's not unicode safe.
   (Vincent Ladeuil, #563997)
 
-* Don't mention --no-strict when we just issue the warning about unclean trees.
-  (Vincent Ladeuil, #401599)
-
-* Fixed ``AssertionError`` when accessing smart servers running Bazaar
-  versions before 1.6.
-  (Andrew Bennetts, #528041)
-
 * Reduce peak memory by one copy of compressed text.
   (John Arbash Meinel, #566940)
 
-* Show the filenames when a file rename fails so that the error will be
-  more comprehensible.
-  (Martin Pool, #491763)
-
 Improvements
 ************
 
-* ``append_revisions_only`` will now be interpreted as a boolean and a
+* ``append_revisions_only`` will no be interpreted as a boolean and a
   warning emitted if illegal values are used. Note that for projects
   that needs to maintain compatibility with previsous bzr versions,
   only 'True' and 'False' strings must be used (previous versions of
@@ -84,28 +64,9 @@
 API Changes
 ***********
 
-* Added ``bzrlib.merge.PerFileMerger``, a more convenient way to write
-  some kinds of ``merge_file_content`` hook functions.
-  (Andrew Bennetts)
-  
-* `BzrDir`, `Branch`, `Repository` and `WorkingTree` now all support `user_url`,
-  `user_transport`, `control_url` and `control_transport` members pointing
-  respectively to the directory containing the ``.bzr`` control directory, 
-  and to the directory within ``.bzr`` used for the particular component.
-  All of them inherit from `ControlComponent` which provides default
-  implementations.
-  (Martin Pool)
-
 Internals
 *********
 
-* ``_remember_remote_is_before`` no longer raises AssertionError when
-  suboptimal network behaviour is noticed; instead it just mutters to the
-  log file (and warns the user if they have set the ``hpss`` debug flag).
-  This was causing unnecessary aborts for performance bugs that are minor
-  at worst.
-  (Andrew Bennetts, #528041)
-
 * Permit bzr to run under ``python -OO`` which reduces the size of bytecode
   files loaded from disk. To ensure docstrings needed for help are never
   stripped, the prefix ``__doc__ =`` should now be used.
@@ -114,16 +75,9 @@
 Testing
 *******
 
-* Added ``bzrlib.tests.matchers`` as a place to put matchers, along with
-  our first in-tree matcher. See the module docstring for details.
-  (Robert Collins)
-
-* ``bzr selftest --parallel=subprocess`` now works correctly on win32.
+ * ``bzr selftest --parallel=subprocess`` now works correctly on win32.
    (Gordon Tyler, #551332)
 
-* Workaround ``Crypto.Random`` check leading to spurious test
-  failures on Lucid, FreeBSD and gentoo.  
-  (Vincent Ladeuil, #528436)
 
 bzr 2.2b2
 #########
@@ -188,13 +142,9 @@
   (Andrew Bennetts)
 
 * When invoked with a range revision, ``bzr log`` doesn't show revisions
-  that are not part of the Y revisions ancestry anymore when invoked with
-  -rX..Y.
+  that are not part of the ancestry anymore.
   (Vincent Ladeuil, #474807)
 
-* Properly handle ``param_name`` attribute for ``ListOption``.
-  (Martin von Gagern, 387117)
-
 Improvements
 ************
 
@@ -527,38 +477,6 @@
   happens, and another warning will be written if the log file could not
   be closed after retrying 100 times.  (Andrew Bennetts, #531746)
 
-bzr 2.1.2
-#########
-
-:2.1.2: NOT RELEASED YET
-
-Bug Fixes
-*********
-
-* ``bzr switch`` does not die if a ConfigurableFileMerger is used.
-  (Aaron Bentley, #559436)
-
-* Fixed ``AssertionError`` when accessing smart servers running Bazaar
-  versions before 1.6.
-  (Andrew Bennetts, #528041)
-
-* Reset ``siginterrupt`` flag to False every time we handle a signal
-  installed with ``set_signal_handler(..., restart_syscall=True)`` (from
-  ``bzrlib.osutils``.  Reduces the likelihood of "Interrupted System Call"
-  errors after two window resizes.
-  (Andrew Bennetts)
-
-Internals
-*********
-
-* ``_remember_remote_is_before`` no longer raises AssertionError when
-  suboptimal network behaviour is noticed; instead it just mutters to the
-  log file (and warns the user if they have set the ``hpss`` debug flag).
-  This was causing unnecessary aborts for performance bugs that are minor
-  at worst.
-  (Andrew Bennetts, #528041)
-
-
 bzr 2.1.1
 #########
 
@@ -592,12 +510,6 @@
   problems importing bzrlib from a non-main thread.
   (Elliot Murphy, #521989)
 
-* Repositories accessed via a smart server now reject being stacked on a
-  repository in an incompatible format, as is the case when accessing them
-  via other methods.  This was causing fetches from those repositories via
-  a smart server (e.g. using ``bzr branch``) to receive invalid data.
-  (Andrew Bennetts, #562380)
-
 * Standardize the error handling when creating a new ``StaticTuple``
   (problems will raise TypeError). (Matt Nordhoff, #457979)
 

=== modified file 'bzrlib/_readdir_py.py'
--- bzrlib/_readdir_py.py	2010-04-30 11:03:59 +0000
+++ bzrlib/_readdir_py.py	2009-03-23 14:59:43 +0000
@@ -17,6 +17,7 @@
 """Python implementation of readdir interface."""
 
 
+import os
 import stat
 
 

=== modified file 'bzrlib/add.py'
--- bzrlib/add.py	2010-04-30 11:03:59 +0000
+++ bzrlib/add.py	2009-04-04 02:50:01 +0000
@@ -16,11 +16,15 @@
 
 """Helper functions for adding files to working trees."""
 
+import errno
+import os
 import sys
 
 import bzrlib.bzrdir
+import bzrlib.errors as errors
 import bzrlib.osutils
 from bzrlib.symbol_versioning import *
+from bzrlib.workingtree import WorkingTree
 
 
 class AddAction(object):

=== modified file 'bzrlib/atomicfile.py'
--- bzrlib/atomicfile.py	2010-04-30 11:03:59 +0000
+++ bzrlib/atomicfile.py	2010-03-10 13:25:36 +0000
@@ -16,6 +16,7 @@
 
 
 import os
+import sys
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2010-04-28 09:40:23 +0000
+++ bzrlib/branch.py	2010-04-23 07:15:23 +0000
@@ -63,12 +63,23 @@
 BZR_BRANCH_FORMAT_6 = "Bazaar Branch Format 6 (bzr 0.15)\n"
 
 
-class Branch(bzrdir.ControlComponent):
+# TODO: Maybe include checks for common corruption of newlines, etc?
+
+# TODO: Some operations like log might retrieve the same revisions
+# repeatedly to calculate deltas.  We could perhaps have a weakref
+# cache in memory to make this faster.  In general anything can be
+# cached in memory between lock and unlock operations. .. nb thats
+# what the transaction identity map provides
+
+
+######################################################################
+# branch objects
+
+class Branch(object):
     """Branch holding a history of revisions.
 
-    :ivar base:
-        Base directory/url of the branch; using control_url and
-        control_transport is more standardized.
+    base
+        Base directory/url of the branch.
 
     hooks: An instance of BranchHooks.
     """
@@ -76,14 +87,6 @@
     # - RBC 20060112
     base = None
 
-    @property
-    def control_transport(self):
-        return self._transport
-
-    @property
-    def user_transport(self):
-        return self.bzrdir.user_transport
-
     def __init__(self, *ignored, **ignored_too):
         self.tags = self._format.make_tags(self)
         self._revision_history_cache = None
@@ -104,7 +107,7 @@
         """Activate the branch/repository from url as a fallback repository."""
         repo = self._get_fallback_repository(url)
         if repo.has_same_location(self.repository):
-            raise errors.UnstackableLocationError(self.user_url, url)
+            raise errors.UnstackableLocationError(self.base, url)
         self.repository.add_fallback_repository(repo)
 
     def break_lock(self):
@@ -417,8 +420,6 @@
             * 'include' - the stop revision is the last item in the result
             * 'with-merges' - include the stop revision and all of its
               merged revisions in the result
-            * 'with-merges-without-common-ancestry' - filter out revisions 
-              that are in both ancestries
         :param direction: either 'reverse' or 'forward':
             * reverse means return the start_revision_id first, i.e.
               start at the most recent revision and go backwards in history
@@ -455,7 +456,7 @@
             stop_revision_id, stop_rule)
         # Make sure we don't return revisions that are not part of the
         # start_revision_id ancestry.
-        filtered = self._filter_start_non_ancestors(filtered)
+        filtered = self._filter_non_ancestors(filtered)
         if direction == 'reverse':
             return filtered
         if direction == 'forward':
@@ -498,18 +499,6 @@
                        node.end_of_merge)
                 if rev_id == stop_revision_id:
                     return
-        elif stop_rule == 'with-merges-without-common-ancestry':
-            # We want to exclude all revisions that are already part of the
-            # stop_revision_id ancestry.
-            graph = self.repository.get_graph()
-            ancestors = graph.find_unique_ancestors(start_revision_id,
-                                                    [stop_revision_id])
-            for node in rev_iter:
-                rev_id = node.key[-1]
-                if rev_id not in ancestors:
-                    continue
-                yield (rev_id, node.merge_depth, node.revno,
-                       node.end_of_merge)
         elif stop_rule == 'with-merges':
             stop_rev = self.repository.get_revision(stop_revision_id)
             if stop_rev.parent_ids:
@@ -538,7 +527,7 @@
         else:
             raise ValueError('invalid stop_rule %r' % stop_rule)
 
-    def _filter_start_non_ancestors(self, rev_iter):
+    def _filter_non_ancestors(self, rev_iter):
         # If we started from a dotted revno, we want to consider it as a tip
         # and don't want to yield revisions that are not part of its
         # ancestry. Given the order guaranteed by the merge sort, we will see
@@ -605,11 +594,11 @@
         :param other: The branch to bind to
         :type other: Branch
         """
-        raise errors.UpgradeRequired(self.user_url)
+        raise errors.UpgradeRequired(self.base)
 
     def set_append_revisions_only(self, enabled):
         if not self._format.supports_set_append_revisions_only():
-            raise errors.UpgradeRequired(self.user_url)
+            raise errors.UpgradeRequired(self.base)
         if enabled:
             value = 'True'
         else:
@@ -663,7 +652,7 @@
     def get_old_bound_location(self):
         """Return the URL of the branch we used to be bound to
         """
-        raise errors.UpgradeRequired(self.user_url)
+        raise errors.UpgradeRequired(self.base)
 
     def get_commit_builder(self, parents, config=None, timestamp=None,
                            timezone=None, committer=None, revprops=None,
@@ -747,7 +736,7 @@
             stacking.
         """
         if not self._format.supports_stacking():
-            raise errors.UnstackableBranchFormat(self._format, self.user_url)
+            raise errors.UnstackableBranchFormat(self._format, self.base)
         # XXX: Changing from one fallback repository to another does not check
         # that all the data you need is present in the new fallback.
         # Possibly it should.
@@ -904,7 +893,7 @@
 
     def unbind(self):
         """Older format branches cannot bind or unbind."""
-        raise errors.UpgradeRequired(self.user_url)
+        raise errors.UpgradeRequired(self.base)
 
     def last_revision(self):
         """Return last revision id, or NULL_REVISION."""
@@ -1070,7 +1059,7 @@
         try:
             return urlutils.join(self.base[:-1], parent)
         except errors.InvalidURLJoin, e:
-            raise errors.InaccessibleParent(parent, self.user_url)
+            raise errors.InaccessibleParent(parent, self.base)
 
     def _get_parent_location(self):
         raise NotImplementedError(self._get_parent_location)
@@ -1575,7 +1564,7 @@
             elsewhere)
         :return: a branch in this format
         """
-        mutter('creating branch %r in %s', self, a_bzrdir.user_url)
+        mutter('creating branch %r in %s', self, a_bzrdir.transport.base)
         branch_transport = a_bzrdir.get_branch_transport(self, name=name)
         lock_map = {
             'metadir': ('lock', lockdir.LockDir),
@@ -1968,8 +1957,8 @@
             if format.__class__ != self.__class__:
                 raise AssertionError("wrong format %r found for %r" %
                     (format, self))
-        transport = a_bzrdir.get_branch_transport(None, name=name)
         try:
+            transport = a_bzrdir.get_branch_transport(None, name=name)
             control_files = lockable_files.LockableFiles(transport, 'lock',
                                                          lockdir.LockDir)
             return self._branch_class()(_format=self,
@@ -2173,10 +2162,10 @@
             # this format does not implement branch itself, thus the implicit
             # creation contract must see it as uninitializable
             raise errors.UninitializableFormat(self)
-        mutter('creating branch reference in %s', a_bzrdir.user_url)
+        mutter('creating branch reference in %s', a_bzrdir.transport.base)
         branch_transport = a_bzrdir.get_branch_transport(self, name=name)
         branch_transport.put_bytes('location',
-            target_branch.bzrdir.user_url)
+            target_branch.bzrdir.root_transport.base)
         branch_transport.put_bytes('format', self.get_format_string())
         branch = self.open(
             a_bzrdir, name, _found=True,
@@ -2304,10 +2293,9 @@
 
     def __str__(self):
         if self.name is None:
-            return '%s(%s)' % (self.__class__.__name__, self.user_url)
+            return '%s(%r)' % (self.__class__.__name__, self.base)
         else:
-            return '%s(%s,%s)' % (self.__class__.__name__, self.user_url,
-                self.name)
+            return '%s(%r,%r)' % (self.__class__.__name__, self.base, self.name)
 
     __repr__ = __str__
 
@@ -2528,7 +2516,7 @@
         return result
 
     def get_stacked_on_url(self):
-        raise errors.UnstackableBranchFormat(self._format, self.user_url)
+        raise errors.UnstackableBranchFormat(self._format, self.base)
 
     def set_push_location(self, location):
         """See Branch.set_push_location."""
@@ -2724,7 +2712,7 @@
         if _mod_revision.is_null(last_revision):
             return
         if last_revision not in self._lefthand_history(revision_id):
-            raise errors.AppendRevisionsOnlyViolation(self.user_url)
+            raise errors.AppendRevisionsOnlyViolation(self.base)
 
     def _gen_revision_history(self):
         """Generate the revision history from last revision
@@ -2830,7 +2818,7 @@
         if branch_location is None:
             return Branch.reference_parent(self, file_id, path,
                                            possible_transports)
-        branch_location = urlutils.join(self.user_url, branch_location)
+        branch_location = urlutils.join(self.base, branch_location)
         return Branch.open(branch_location,
                            possible_transports=possible_transports)
 
@@ -2951,7 +2939,7 @@
     """
 
     def get_stacked_on_url(self):
-        raise errors.UnstackableBranchFormat(self._format, self.user_url)
+        raise errors.UnstackableBranchFormat(self._format, self.base)
 
 
 ######################################################################
@@ -3044,7 +3032,7 @@
         :param verbose: Requests more detailed display of what was checked,
             if any.
         """
-        note('checked branch %s format %s', self.branch.user_url,
+        note('checked branch %s format %s', self.branch.base,
             self.branch._format)
         for error in self.errors:
             note('found error:%s', error)
@@ -3379,7 +3367,7 @@
         if local and not bound_location:
             raise errors.LocalRequiresBoundBranch()
         master_branch = None
-        if not local and bound_location and self.source.user_url != bound_location:
+        if not local and bound_location and self.source.base != bound_location:
             # not pulling from master, so we need to update master.
             master_branch = self.target.get_master_branch(possible_transports)
             master_branch.lock_write()

=== modified file 'bzrlib/bugtracker.py'
--- bzrlib/bugtracker.py	2010-04-30 11:03:59 +0000
+++ bzrlib/bugtracker.py	2010-02-17 17:11:16 +0000
@@ -14,7 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from bzrlib import registry
+from bzrlib import registry, help_topics
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 from bzrlib import errors, urlutils

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2010-05-03 09:07:50 +0000
+++ bzrlib/builtins.py	2010-04-23 11:11:22 +0000
@@ -504,7 +504,9 @@
                 if (working.has_changes()):
                     raise errors.UncommittedChanges(working)
 
-            if working.user_url != working.branch.user_url:
+            working_path = working.bzrdir.root_transport.base
+            branch_path = working.branch.bzrdir.root_transport.base
+            if working_path != branch_path:
                 raise errors.BzrCommandError("You cannot remove the working tree"
                                              " from a lightweight checkout")
 
@@ -1132,10 +1134,8 @@
         else:
             revision_id = None
         if tree is not None and revision_id is None:
-            tree.check_changed_or_out_of_date(
-                strict, 'push_strict',
-                more_error='Use --no-strict to force the push.',
-                more_warning='Uncommitted changes will not be pushed.')
+            tree.warn_if_changed_or_out_of_date(
+                strict, 'push_strict', 'Use --no-strict to force the push.')
         # Get the stacked_on branch, if any
         if stacked_on is not None:
             stacked_on = urlutils.normalize_url(stacked_on)
@@ -2299,10 +2299,6 @@
                    help='Show changes made in each revision as a patch.'),
             Option('include-merges',
                    help='Show merged revisions like --levels 0 does.'),
-            Option('exclude-common-ancestry',
-                   help='Display only the revisions that are not part'
-                   ' of both ancestries (require -rX..Y)'
-                   )
             ]
     encoding_type = 'replace'
 
@@ -2318,19 +2314,13 @@
             message=None,
             limit=None,
             show_diff=False,
-            include_merges=False,
-            exclude_common_ancestry=False,
-            ):
+            include_merges=False):
         from bzrlib.log import (
             Logger,
             make_log_request_dict,
             _get_info_for_log_files,
             )
         direction = (forward and 'forward') or 'reverse'
-        if (exclude_common_ancestry
-            and (revision is None or len(revision) != 2)):
-            raise errors.BzrCommandError(
-                '--exclude-common-ancestry requires -r with two revisions')
         if include_merges:
             if levels is None:
                 levels = 0
@@ -2429,9 +2419,7 @@
             direction=direction, specific_fileids=file_ids,
             start_revision=rev1, end_revision=rev2, limit=limit,
             message_search=message, delta_type=delta_type,
-            diff_type=diff_type, _match_using_deltas=match_using_deltas,
-            exclude_common_ancestry=exclude_common_ancestry,
-            )
+            diff_type=diff_type, _match_using_deltas=match_using_deltas)
         Logger(b, rqst).show(lf)
 
 
@@ -3073,7 +3061,7 @@
                          "the master branch until a normal commit "
                          "is performed."
                     ),
-             Option('show-diff', short_name='p',
+             Option('show-diff',
                     help='When no message is supplied, show the diff along'
                     ' with the status summary in the message editor.'),
              ]
@@ -4681,7 +4669,6 @@
 
 class cmd_bind(Command):
     __doc__ = """Convert the current branch into a checkout of the supplied branch.
-    If no branch is supplied, rebind to the last bound location.
 
     Once converted into a checkout, commits must succeed on the master branch
     before they will be applied to the local branch.

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2010-04-28 07:03:38 +0000
+++ bzrlib/bzrdir.py	2010-04-22 17:08:27 +0000
@@ -86,42 +86,9 @@
     registry,
     symbol_versioning,
     )
-    
-    
-class ControlComponent(object):
-    """Abstract base class for control directory components.
-    
-    This provides interfaces that are common across bzrdirs, 
-    repositories, branches, and workingtree control directories.
-    
-    They all expose two urls and transports: the *user* URL is the 
-    one that stops above the control directory (eg .bzr) and that 
-    should normally be used in messages, and the *control* URL is
-    under that in eg .bzr/checkout and is used to read the control
-    files.
-    
-    This can be used as a mixin and is intended to fit with 
-    foreign formats.
-    """
-    
-    @property
-    def control_transport(self):
-        raise NotImplementedError
-   
-    @property
-    def control_url(self):
-        return self.control_transport.base
-    
-    @property
-    def user_transport(self):
-        raise NotImplementedError
-        
-    @property
-    def user_url(self):
-        return self.user_transport.base
-    
-
-class BzrDir(ControlComponent):
+
+
+class BzrDir(object):
     """A .bzr control diretory.
 
     BzrDir instances let you create or open any of the things that can be
@@ -294,8 +261,8 @@
                 # copied, and finally if we are copying up to a specific
                 # revision_id then we can use the pending-ancestry-result which
                 # does not require traversing all of history to describe it.
-                if (result_repo.user_url == result.user_url
-                    and not require_stacking and
+                if (result_repo.bzrdir.root_transport.base ==
+                    result.root_transport.base and not require_stacking and
                     revision_id is not None):
                     fetch_spec = graph.PendingAncestryResult(
                         [revision_id], local_repo)
@@ -491,7 +458,7 @@
             stop = False
             stack_on = config.get_default_stack_on()
             if stack_on is not None:
-                stack_on_pwd = found_bzrdir.user_url
+                stack_on_pwd = found_bzrdir.root_transport.base
                 stop = True
             # does it have a repository ?
             try:
@@ -499,8 +466,8 @@
             except errors.NoRepositoryPresent:
                 repository = None
             else:
-                if (found_bzrdir.user_url != self.user_url 
-                    and not repository.is_shared()):
+                if ((found_bzrdir.root_transport.base !=
+                     self.root_transport.base) and not repository.is_shared()):
                     # Don't look higher, can't use a higher shared repo.
                     repository = None
                     stop = True
@@ -702,7 +669,7 @@
             if stop:
                 return result
             next_transport = found_bzrdir.root_transport.clone('..')
-            if (found_bzrdir.user_url == next_transport.base):
+            if (found_bzrdir.root_transport.base == next_transport.base):
                 # top of the file system
                 return None
             # find the next containing bzrdir
@@ -725,7 +692,7 @@
                 repository = found_bzrdir.open_repository()
             except errors.NoRepositoryPresent:
                 return None, False
-            if found_bzrdir.user_url == self.user_url:
+            if found_bzrdir.root_transport.base == self.root_transport.base:
                 return repository, True
             elif repository.is_shared():
                 return repository, True
@@ -847,19 +814,9 @@
         :param _transport: the transport this dir is based at.
         """
         self._format = _format
-        # these are also under the more standard names of 
-        # control_transport and user_transport
         self.transport = _transport.clone('.bzr')
         self.root_transport = _transport
         self._mode_check_done = False
-        
-    @property 
-    def user_transport(self):
-        return self.root_transport
-        
-    @property
-    def control_transport(self):
-        return self.transport
 
     def is_control_filename(self, filename):
         """True if filename is the name of a path which is reserved for bzrdir's.
@@ -2735,7 +2692,7 @@
             if isinstance(self.bzrdir.transport, local.LocalTransport):
                 self.bzrdir.get_workingtree_transport(None).delete('stat-cache')
             self._convert_to_weaves()
-            return BzrDir.open(self.bzrdir.user_url)
+            return BzrDir.open(self.bzrdir.root_transport.base)
         finally:
             self.pb.finished()
 
@@ -2988,7 +2945,7 @@
         try:
             ui.ui_factory.note('starting upgrade from format 5 to 6')
             self._convert_to_prefixed()
-            return BzrDir.open(self.bzrdir.user_url)
+            return BzrDir.open(self.bzrdir.root_transport.base)
         finally:
             pb.finished()
 
@@ -3116,7 +3073,7 @@
             BzrDirMetaFormat1().get_format_string(),
             mode=self.file_mode)
         self.pb.finished()
-        return BzrDir.open(self.bzrdir.user_url)
+        return BzrDir.open(self.bzrdir.root_transport.base)
 
     def make_lock(self, name):
         """Make a lock for the new control dir name."""
@@ -3703,7 +3660,7 @@
             try:
                 stack_on = urlutils.rebase_url(self._stack_on,
                     self._stack_on_pwd,
-                    branch.user_url)
+                    branch.bzrdir.root_transport.base)
             except errors.InvalidRebaseURLs:
                 stack_on = self._get_full_stack_on()
         try:

=== modified file 'bzrlib/check.py'
--- bzrlib/check.py	2010-04-30 11:35:43 +0000
+++ bzrlib/check.py	2009-09-18 01:06:10 +0000
@@ -46,9 +46,13 @@
   indicating that the revision was found/not found.
 """
 
-from bzrlib import errors
+from bzrlib import errors, osutils
+from bzrlib import repository as _mod_repository
+from bzrlib import revision
 from bzrlib.branch import Branch
 from bzrlib.bzrdir import BzrDir
+from bzrlib.errors import BzrCheckError
+from bzrlib.repository import Repository
 from bzrlib.revision import NULL_REVISION
 from bzrlib.symbol_versioning import deprecated_function, deprecated_in
 from bzrlib.trace import note
@@ -188,8 +192,8 @@
 
     def _report_repo_results(self, verbose):
         note('checked repository %s format %s',
-            self.repository.user_url,
-            self.repository._format)
+             self.repository.bzrdir.root_transport,
+             self.repository._format)
         note('%6d revisions', self.checked_rev_cnt)
         note('%6d file-ids', len(self.checked_weaves))
         if verbose:
@@ -447,7 +451,7 @@
             if do_repo or do_branch or do_tree:
                 if do_repo:
                     note("Checking repository at '%s'."
-                         % (repo.user_url,))
+                         % (repo.bzrdir.root_transport.base,))
                 result = repo.check(None, callback_refs=needed_refs,
                     check_repo=do_repo)
                 result.report_results(verbose)

=== modified file 'bzrlib/clean_tree.py'
--- bzrlib/clean_tree.py	2010-04-30 11:03:59 +0000
+++ bzrlib/clean_tree.py	2009-03-23 14:59:43 +0000
@@ -15,10 +15,12 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 
+import errno
 import os
 import shutil
+import sys
 
-from bzrlib.osutils import isdir
+from bzrlib.osutils import has_symlinks, isdir
 from bzrlib.trace import note
 from bzrlib.workingtree import WorkingTree
 

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2010-04-30 11:35:43 +0000
+++ bzrlib/commit.py	2010-04-10 09:22:04 +0000
@@ -49,12 +49,20 @@
 # TODO: Change the parameter 'rev_id' to 'revision_id' to be consistent with
 # the rest of the code; add a deprecation of the old name.
 
+import os
+import re
+import sys
+import time
+
+from cStringIO import StringIO
+
 from bzrlib import (
     debug,
     errors,
     revision,
     trace,
     tree,
+    xml_serializer,
     )
 from bzrlib.branch import Branch
 from bzrlib.cleanup import OperationWithCleanups
@@ -64,13 +72,20 @@
                            StrictCommitFailed
                            )
 from bzrlib.osutils import (get_user_encoding,
-                            is_inside_any,
+                            kind_marker, isdir,isfile, is_inside_any,
+                            is_inside_or_parent_of_any,
                             minimum_path_selection,
+                            quotefn, sha_file, split_lines,
                             splitpath,
                             )
-from bzrlib.trace import mutter, note, is_quiet
+from bzrlib.testament import Testament
+from bzrlib.trace import mutter, note, warning, is_quiet
 from bzrlib.inventory import Inventory, InventoryEntry, make_entry
 from bzrlib import symbol_versioning
+from bzrlib.symbol_versioning import (deprecated_passed,
+        deprecated_function,
+        DEPRECATED_PARAMETER)
+from bzrlib.workingtree import WorkingTree
 from bzrlib.urlutils import unescape_for_display
 import bzrlib.ui
 

=== modified file 'bzrlib/conflicts.py'
--- bzrlib/conflicts.py	2010-04-30 11:35:43 +0000
+++ bzrlib/conflicts.py	2010-04-02 19:12:58 +0000
@@ -18,6 +18,7 @@
 # point down
 
 import os
+import re
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """

=== modified file 'bzrlib/delta.py'
--- bzrlib/delta.py	2010-04-30 11:35:43 +0000
+++ bzrlib/delta.py	2010-03-19 23:58:06 +0000
@@ -15,9 +15,12 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 from bzrlib import (
+    errors,
     osutils,
     )
-from bzrlib.trace import is_quiet
+from bzrlib.inventory import InventoryEntry
+from bzrlib.trace import mutter, is_quiet
+from bzrlib.symbol_versioning import deprecated_function
 
 
 class TreeDelta(object):

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2010-04-30 11:35:43 +0000
+++ bzrlib/diff.py	2010-04-19 04:10:53 +0000
@@ -17,6 +17,7 @@
 import difflib
 import os
 import re
+import shutil
 import string
 import sys
 

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2010-04-21 11:27:04 +0000
+++ bzrlib/errors.py	2010-03-24 14:15:01 +0000
@@ -2176,7 +2176,7 @@
 
     def __init__(self, repo):
         BzrError.__init__(self)
-        self.repo_path = repo.user_url
+        self.repo_path = repo.bzrdir.root_transport.base
 
 
 class InconsistentDelta(BzrError):
@@ -2754,7 +2754,7 @@
 
     def __init__(self, bzrdir):
         import bzrlib.urlutils as urlutils
-        display_url = urlutils.unescape_for_display(bzrdir.user_url,
+        display_url = urlutils.unescape_for_display(bzrdir.root_transport.base,
                                                     'ascii')
         BzrError.__init__(self, bzrdir=bzrdir, display_url=display_url)
 
@@ -2835,7 +2835,7 @@
             more = ' ' + more
         import bzrlib.urlutils as urlutils
         display_url = urlutils.unescape_for_display(
-            tree.user_url, 'ascii')
+            tree.bzrdir.root_transport.base, 'ascii')
         BzrError.__init__(self, tree=tree, display_url=display_url, more=more)
 
 

=== modified file 'bzrlib/externalcommand.py'
--- bzrlib/externalcommand.py	2010-04-30 11:03:59 +0000
+++ bzrlib/externalcommand.py	2009-03-23 14:59:43 +0000
@@ -20,8 +20,10 @@
 
 
 import os
+import sys
 
 from bzrlib.commands import Command
+from bzrlib.osutils import pathjoin
 
 
 class ExternalCommand(Command):

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2010-04-30 11:35:43 +0000
+++ bzrlib/fetch.py	2010-03-21 21:39:33 +0000
@@ -35,6 +35,7 @@
 import bzrlib
 from bzrlib import (
     errors,
+    symbol_versioning,
     ui,
     )
 from bzrlib.revision import NULL_REVISION

=== modified file 'bzrlib/foreign.py'
--- bzrlib/foreign.py	2010-04-28 10:33:44 +0000
+++ bzrlib/foreign.py	2010-04-20 22:38:03 +0000
@@ -297,10 +297,8 @@
             source_branch = Branch.open(directory)
             source_wt = None
         if source_wt is not None:
-            source_wt.check_changed_or_out_of_date(
-                strict, 'dpush_strict',
-                more_error='Use --no-strict to force the push.',
-                more_warning='Uncommitted changes will not be pushed.')
+            source_wt.warn_if_changed_or_out_of_date(
+                strict, 'dpush_strict', 'Use --no-strict to force the push.')
         stored_loc = source_branch.get_push_location()
         if location is None:
             if stored_loc is None:

=== modified file 'bzrlib/help.py'
--- bzrlib/help.py	2010-04-30 11:03:59 +0000
+++ bzrlib/help.py	2010-02-17 17:11:16 +0000
@@ -30,6 +30,7 @@
     help_topics,
     osutils,
     plugin,
+    symbol_versioning,
     )
 
 

=== modified file 'bzrlib/hooks.py'
--- bzrlib/hooks.py	2010-04-30 11:03:59 +0000
+++ bzrlib/hooks.py	2010-03-12 19:59:50 +0000
@@ -18,6 +18,7 @@
 """Support for plugin hooking logic."""
 from bzrlib import registry
 from bzrlib.lazy_import import lazy_import
+from bzrlib.symbol_versioning import deprecated_method
 lazy_import(globals(), """
 import textwrap
 

=== modified file 'bzrlib/identitymap.py'
--- bzrlib/identitymap.py	2010-04-30 11:03:59 +0000
+++ bzrlib/identitymap.py	2009-03-23 14:59:43 +0000
@@ -20,6 +20,7 @@
 
 from bzrlib import (
     errors,
+    osutils,
     )
 
 

=== modified file 'bzrlib/ignores.py'
--- bzrlib/ignores.py	2010-04-30 07:54:33 +0000
+++ bzrlib/ignores.py	2010-04-26 13:51:08 +0000
@@ -176,11 +176,10 @@
 
 
 def tree_ignores_add_patterns(tree, name_pattern_list):
-    """Add more ignore patterns to the ignore file in a tree.
-    If ignore file does not exist then it will be created.
-    The ignore file will be automatically added under version control.
+    """Retrieve a list of ignores from the ignore file in a tree.
 
-    :param tree: Working tree to update the ignore list.
+    :param tree: Tree to retrieve the ignore list from.
+    :return:
     """
     ifn = tree.abspath(bzrlib.IGNORE_FILENAME)
     if tree.has_filename(ifn):
@@ -207,5 +206,5 @@
     finally:
         f.close()
 
-    if not tree.path2id(bzrlib.IGNORE_FILENAME):
-        tree.add([bzrlib.IGNORE_FILENAME])
+    if not tree.path2id('.bzrignore'):
+        tree.add(['.bzrignore'])

=== modified file 'bzrlib/info.py'
--- bzrlib/info.py	2010-04-30 11:35:43 +0000
+++ bzrlib/info.py	2010-02-17 17:11:16 +0000
@@ -17,11 +17,13 @@
 __all__ = ['show_bzrdir_info']
 
 from cStringIO import StringIO
+import os
 import time
 import sys
 
 from bzrlib import (
     bzrdir,
+    diff,
     errors,
     hooks as _mod_hooks,
     osutils,
@@ -78,9 +80,9 @@
 
 def gather_location_info(repository, branch=None, working=None):
     locs = {}
-    repository_path = repository.user_url
+    repository_path = repository.bzrdir.root_transport.base
     if branch is not None:
-        branch_path = branch.user_url
+        branch_path = branch.bzrdir.root_transport.base
         master_path = branch.get_bound_location()
         if master_path is None:
             master_path = branch_path
@@ -88,7 +90,7 @@
         branch_path = None
         master_path = None
     if working:
-        working_path = working.user_url
+        working_path = working.bzrdir.root_transport.base
         if working_path != branch_path:
             locs['light checkout root'] = working_path
         if master_path != branch_path:
@@ -418,8 +420,8 @@
         if branch is None and tree is not None:
             phrase = "branchless tree"
         else:
-            if (tree is not None and tree.user_url !=
-                branch.user_url):
+            if (tree is not None and tree.bzrdir.root_transport.base !=
+                branch.bzrdir.root_transport.base):
                 independence = ''
                 phrase = "Lightweight checkout"
             elif branch.get_bound_location() is not None:
@@ -444,7 +446,8 @@
     """
     candidates  = []
     if (branch is not None and tree is not None and
-        branch.user_url != tree.user_url):
+        branch.bzrdir.root_transport.base !=
+        tree.bzrdir.root_transport.base):
         branch = None
         repository = None
     non_aliases = set(bzrdir.format_registry.keys())

=== modified file 'bzrlib/lockable_files.py'
--- bzrlib/lockable_files.py	2010-04-30 11:03:59 +0000
+++ bzrlib/lockable_files.py	2009-10-15 02:11:18 +0000
@@ -14,6 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+from cStringIO import StringIO
+
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 import codecs
@@ -32,6 +34,10 @@
 from bzrlib.decorators import (
     only_raises,
     )
+from bzrlib.symbol_versioning import (
+    deprecated_in,
+    deprecated_method,
+    )
 
 
 # XXX: The tracking here of lock counts and whether the lock is held is

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2010-04-14 12:30:17 +0000
+++ bzrlib/log.py	2010-04-14 10:38:57 +0000
@@ -220,18 +220,14 @@
     'direction': 'reverse',
     'levels': 1,
     'generate_tags': True,
-    'exclude_common_ancestry': False,
     '_match_using_deltas': True,
     }
 
 
 def make_log_request_dict(direction='reverse', specific_fileids=None,
-                          start_revision=None, end_revision=None, limit=None,
-                          message_search=None, levels=1, generate_tags=True,
-                          delta_type=None,
-                          diff_type=None, _match_using_deltas=True,
-                          exclude_common_ancestry=False,
-                          ):
+    start_revision=None, end_revision=None, limit=None,
+    message_search=None, levels=1, generate_tags=True, delta_type=None,
+    diff_type=None, _match_using_deltas=True):
     """Convenience function for making a logging request dictionary.
 
     Using this function may make code slightly safer by ensuring
@@ -275,9 +271,6 @@
       algorithm used for matching specific_fileids. This parameter
       may be removed in the future so bzrlib client code should NOT
       use it.
-
-    :param exclude_common_ancestry: Whether -rX..Y should be interpreted as a
-      range operator or as a graph difference.
     """
     return {
         'direction': direction,
@@ -290,7 +283,6 @@
         'generate_tags': generate_tags,
         'delta_type': delta_type,
         'diff_type': diff_type,
-        'exclude_common_ancestry': exclude_common_ancestry,
         # Add 'private' attributes for features that may be deprecated
         '_match_using_deltas': _match_using_deltas,
     }
@@ -467,8 +459,7 @@
             self.branch, self.start_rev_id, self.end_rev_id,
             rqst.get('direction'),
             generate_merge_revisions=generate_merge_revisions,
-            delayed_graph_generation=delayed_graph_generation,
-            exclude_common_ancestry=rqst.get('exclude_common_ancestry'))
+            delayed_graph_generation=delayed_graph_generation)
 
         # Apply the other filters
         return make_log_rev_iterator(self.branch, view_revisions,
@@ -483,8 +474,7 @@
         rqst = self.rqst
         view_revisions = _calc_view_revisions(
             self.branch, self.start_rev_id, self.end_rev_id,
-            rqst.get('direction'), generate_merge_revisions=True,
-            exclude_common_ancestry=rqst.get('exclude_common_ancestry'))
+            rqst.get('direction'), generate_merge_revisions=True)
         if not isinstance(view_revisions, list):
             view_revisions = list(view_revisions)
         view_revisions = _filter_revisions_touching_file_id(self.branch,
@@ -495,18 +485,12 @@
 
 
 def _calc_view_revisions(branch, start_rev_id, end_rev_id, direction,
-                         generate_merge_revisions,
-                         delayed_graph_generation=False,
-                         exclude_common_ancestry=False,
-                         ):
+    generate_merge_revisions, delayed_graph_generation=False):
     """Calculate the revisions to view.
 
     :return: An iterator of (revision_id, dotted_revno, merge_depth) tuples OR
              a list of the same tuples.
     """
-    if (exclude_common_ancestry and start_rev_id == end_rev_id):
-        raise errors.BzrCommandError(
-            '--exclude-common-ancestry requires two different revisions')
     if direction not in ('reverse', 'forward'):
         raise ValueError('invalid direction %r' % direction)
     br_revno, br_rev_id = branch.last_revision_info()
@@ -527,8 +511,7 @@
             iter_revs = reversed(iter_revs)
     else:
         iter_revs = _generate_all_revisions(branch, start_rev_id, end_rev_id,
-                                            direction, delayed_graph_generation,
-                                            exclude_common_ancestry)
+                                            direction, delayed_graph_generation)
         if direction == 'forward':
             iter_revs = _rebase_merge_depth(reverse_by_depth(list(iter_revs)))
     return iter_revs
@@ -559,8 +542,7 @@
 
 
 def _generate_all_revisions(branch, start_rev_id, end_rev_id, direction,
-                            delayed_graph_generation,
-                            exclude_common_ancestry=False):
+                            delayed_graph_generation):
     # On large trees, generating the merge graph can take 30-60 seconds
     # so we delay doing it until a merge is detected, incrementally
     # returning initial (non-merge) revisions while we can.
@@ -612,8 +594,7 @@
     # indented at the end seems slightly nicer in that case.
     view_revisions = chain(iter(initial_revisions),
         _graph_view_revisions(branch, start_rev_id, end_rev_id,
-                              rebase_initial_depths=(direction == 'reverse'),
-                              exclude_common_ancestry=exclude_common_ancestry))
+                              rebase_initial_depths=(direction == 'reverse')))
     return view_revisions
 
 
@@ -678,8 +659,7 @@
 
 
 def _graph_view_revisions(branch, start_rev_id, end_rev_id,
-                          rebase_initial_depths=True,
-                          exclude_common_ancestry=False):
+                          rebase_initial_depths=True):
     """Calculate revisions to view including merges, newest to oldest.
 
     :param branch: the branch
@@ -689,13 +669,9 @@
       revision is found?
     :return: An iterator of (revision_id, dotted_revno, merge_depth) tuples.
     """
-    if exclude_common_ancestry:
-        stop_rule = 'with-merges-without-common-ancestry'
-    else:
-        stop_rule = 'with-merges'
     view_revisions = branch.iter_merge_sorted_revisions(
         start_revision_id=end_rev_id, stop_revision_id=start_rev_id,
-        stop_rule=stop_rule)
+        stop_rule="with-merges")
     if not rebase_initial_depths:
         for (rev_id, merge_depth, revno, end_of_merge
              ) in view_revisions:

=== modified file 'bzrlib/memorytree.py'
--- bzrlib/memorytree.py	2010-04-30 11:03:59 +0000
+++ bzrlib/memorytree.py	2009-04-09 20:23:07 +0000
@@ -25,9 +25,10 @@
 from bzrlib import (
     errors,
     mutabletree,
+    osutils,
     revision as _mod_revision,
     )
-from bzrlib.decorators import needs_read_lock
+from bzrlib.decorators import needs_read_lock, needs_write_lock
 from bzrlib.osutils import sha_file
 from bzrlib.mutabletree import needs_tree_write_lock
 from bzrlib.transport.memory import MemoryTransport

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2010-05-03 04:08:50 +0000
+++ bzrlib/merge.py	2010-04-26 23:36:26 +0000
@@ -93,60 +93,7 @@
         return ('not applicable', None)
 
 
-class PerFileMerger(AbstractPerFileMerger):
-    """Merge individual files when self.file_matches returns True.
-
-    This class is intended to be subclassed.  The file_matches and
-    merge_matching methods should be overridden with concrete implementations.
-    """
-
-    def file_matches(self, params):
-        """Return True if merge_matching should be called on this file.
-
-        Only called with merges of plain files with no clear winner.
-
-        Subclasses must override this.
-        """
-        raise NotImplementedError(self.file_matches)
-
-    def get_filename(self, params, tree):
-        """Lookup the filename (i.e. basename, not path), given a Tree (e.g.
-        self.merger.this_tree) and a MergeHookParams.
-        """
-        return osutils.basename(tree.id2path(params.file_id))
-
-    def get_filepath(self, params, tree):
-        """Calculate the path to the file in a tree.
-
-        :param params: A MergeHookParams describing the file to merge
-        :param tree: a Tree, e.g. self.merger.this_tree.
-        """
-        return tree.id2path(params.file_id)
-
-    def merge_contents(self, params):
-        """Merge the contents of a single file."""
-        # Check whether this custom merge logic should be used.
-        if (
-            # OTHER is a straight winner, rely on default merge.
-            params.winner == 'other' or
-            # THIS and OTHER aren't both files.
-            not params.is_file_merge() or
-            # The filename doesn't match *.xml
-            not self.file_matches(params)):
-            return 'not_applicable', None
-        return self.merge_matching(params)
-
-    def merge_matching(self, params):
-        """Merge the contents of a single file that has matched the criteria
-        in PerFileMerger.merge_contents (is a conflict, is a file,
-        self.file_matches is True).
-
-        Subclasses must override this.
-        """
-        raise NotImplementedError(self.merge_matching)
-
-
-class ConfigurableFileMerger(PerFileMerger):
+class ConfigurableFileMerger(AbstractPerFileMerger):
     """Merge individual files when configured via a .conf file.
 
     This is a base class for concrete custom file merging logic. Concrete
@@ -175,7 +122,7 @@
         if self.name_prefix is None:
             raise ValueError("name_prefix must be set.")
 
-    def file_matches(self, params):
+    def filename_matches_config(self, params):
         """Check whether the file should call the merge hook.
 
         <name_prefix>_merge_files configuration variable is a list of files
@@ -195,12 +142,24 @@
                 affected_files = self.default_files
             self.affected_files = affected_files
         if affected_files:
-            filepath = self.get_filepath(params, self.merger.this_tree)
-            if filepath in affected_files:
+            filename = self.merger.this_tree.id2path(params.file_id)
+            if filename in affected_files:
                 return True
         return False
 
-    def merge_matching(self, params):
+    def merge_contents(self, params):
+        """Merge the contents of a single file."""
+        # First, check whether this custom merge logic should be used.  We
+        # expect most files should not be merged by this handler.
+        if (
+            # OTHER is a straight winner, rely on default merge.
+            params.winner == 'other' or
+            # THIS and OTHER aren't both files.
+            not params.is_file_merge() or
+            # The filename isn't listed in the 'NAME_merge_files' config
+            # option.
+            not self.filename_matches_config(params)):
+            return 'not_applicable', None
         return self.merge_text(params)
 
     def merge_text(self, params):

=== modified file 'bzrlib/missing.py'
--- bzrlib/missing.py	2010-04-30 11:03:59 +0000
+++ bzrlib/missing.py	2009-08-17 18:52:01 +0000
@@ -18,6 +18,8 @@
 
 from bzrlib import (
     log,
+    repository as _mod_repository,
+    tsort,
     )
 import bzrlib.revision as _mod_revision
 

=== modified file 'bzrlib/msgeditor.py'
--- bzrlib/msgeditor.py	2010-04-30 11:35:43 +0000
+++ bzrlib/msgeditor.py	2010-04-07 22:22:27 +0000
@@ -18,6 +18,7 @@
 """Commit message editor support."""
 
 import codecs
+import errno
 import os
 from subprocess import call
 import sys

=== modified file 'bzrlib/mutabletree.py'
--- bzrlib/mutabletree.py	2010-04-22 14:18:17 +0000
+++ bzrlib/mutabletree.py	2010-04-15 06:47:06 +0000
@@ -258,8 +258,7 @@
             return False
 
     @needs_read_lock
-    def check_changed_or_out_of_date(self, strict, opt_name,
-                                     more_error, more_warning):
+    def warn_if_changed_or_out_of_date(self, strict, opt_name, more_msg):
         """Check the tree for uncommitted changes and branch synchronization.
 
         If strict is None and not set in the config files, a warning is issued.
@@ -270,29 +269,25 @@
 
         :param opt_name: strict option name to search in config file.
 
-        :param more_error: Details about how to avoid the check.
-
-        :param more_warning: Details about what is happening.
+        :param more_msg: Details about how to avoid the warnings.
         """
         if strict is None:
             strict = self.branch.get_config().get_user_option_as_bool(opt_name)
         if strict is not False:
-            err_class = None
+            err = None
             if (self.has_changes()):
-                err_class = errors.UncommittedChanges
+                err = errors.UncommittedChanges(self, more=more_msg)
             elif self.last_revision() != self.branch.last_revision():
                 # The tree has lost sync with its branch, there is little
                 # chance that the user is aware of it but he can still force
                 # the action with --no-strict
-                err_class = errors.OutOfDateTree
-            if err_class is not None:
+                err = errors.OutOfDateTree(self, more=more_msg)
+            if err is not None:
                 if strict is None:
-                    err = err_class(self, more=more_warning)
                     # We don't want to interrupt the user if he expressed no
                     # preference about strict.
                     trace.warning('%s', err._format())
                 else:
-                    err = err_class(self, more=more_error)
                     raise err
 
     @needs_read_lock

=== modified file 'bzrlib/option.py'
--- bzrlib/option.py	2010-04-20 08:47:38 +0000
+++ bzrlib/option.py	2010-04-13 04:33:55 +0000
@@ -276,7 +276,7 @@
         parser.add_option(action='callback',
                           callback=self._optparse_callback,
                           type='string', metavar=self.argname.upper(),
-                          help=self.help, dest=self._param_name, default=[],
+                          help=self.help, default=[],
                           *option_strings)
 
     def _optparse_callback(self, option, opt, value, parser):

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2010-05-03 06:25:46 +0000
+++ bzrlib/osutils.py	2010-04-24 09:08:27 +0000
@@ -17,10 +17,12 @@
 import os
 import re
 import stat
-from stat import S_ISREG, S_ISDIR, S_ISLNK, ST_MODE, ST_SIZE
+from stat import (S_ISREG, S_ISDIR, S_ISLNK, ST_MODE, ST_SIZE,
+                  S_ISCHR, S_ISBLK, S_ISFIFO, S_ISSOCK)
 import sys
 import time
 import codecs
+import warnings
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
@@ -360,14 +362,6 @@
     return _win32_fixdrive(tempfile.mkdtemp(*args, **kwargs).replace('\\', '/'))
 
 
-def _add_rename_error_details(e, old, new):
-    new_e = OSError(e.errno, "failed to rename %s to %s: %s"
-        % (old, new, e.strerror))
-    new_e.filename = old
-    new_e.to_filename = new
-    return new_e
-
-
 def _win32_rename(old, new):
     """We expect to be able to atomically replace 'new' with old.
 
@@ -375,7 +369,7 @@
     and then deleted.
     """
     try:
-        fancy_rename(old, new, rename_func=_wrapped_rename, unlink_func=os.unlink)
+        fancy_rename(old, new, rename_func=os.rename, unlink_func=os.unlink)
     except OSError, e:
         if e.errno in (errno.EPERM, errno.EACCES, errno.EBUSY, errno.EINVAL):
             # If we try to rename a non-existant file onto cwd, we get
@@ -386,16 +380,6 @@
         raise
 
 
-def _wrapped_rename(old, new):
-    """Rename a file or directory"""
-    try:
-        os.rename(old, new)
-    except (IOError, OSError), e:
-        # this is eventually called by all rename-like functions, so should 
-        # catch all of them
-        raise _add_rename_error_details(e, old, new)
-
-
 def _mac_getcwd():
     return unicodedata.normalize('NFC', os.getcwdu())
 
@@ -406,8 +390,8 @@
 realpath = _posix_realpath
 pathjoin = os.path.join
 normpath = os.path.normpath
-rename = _wrapped_rename # overridden below on win32
 getcwd = os.getcwdu
+rename = os.rename
 dirname = os.path.dirname
 basename = os.path.basename
 split = os.path.split
@@ -1147,7 +1131,7 @@
 
 
 def relpath(base, path):
-    """Return path relative to base, or raise PathNotChild exception.
+    """Return path relative to base, or raise exception.
 
     The path may be either an absolute path or a path relative to the
     current working directory.
@@ -1155,9 +1139,6 @@
     os.path.commonprefix (python2.4) has a bad bug that it works just
     on string prefixes, assuming that '/u' is a prefix of '/u2'.  This
     avoids that problem.
-
-    NOTE: `base` should not have a trailing slash otherwise you'll get
-    PathNotChild exceptions regardless of `path`.
     """
 
     if len(base) < MIN_ABS_PATHLENGTH:

=== modified file 'bzrlib/plugins/launchpad/lp_directory.py'
--- bzrlib/plugins/launchpad/lp_directory.py	2010-03-30 11:05:14 +0000
+++ bzrlib/plugins/launchpad/lp_directory.py	2010-02-17 17:11:16 +0000
@@ -17,13 +17,14 @@
 
 """Directory lookup that uses Launchpad."""
 
-from urlparse import urlsplit
+from urlparse import urlsplit, urlunsplit
 import xmlrpclib
 
 from bzrlib import (
     debug,
     errors,
     trace,
+    urlutils,
     )
 from bzrlib.transport import (
     get_transport,

=== modified file 'bzrlib/plugins/news_merge/__init__.py'
--- bzrlib/plugins/news_merge/__init__.py	2010-05-03 04:08:50 +0000
+++ bzrlib/plugins/news_merge/__init__.py	2010-04-16 12:59:03 +0000
@@ -21,6 +21,7 @@
 
     [/home/user/code/bzr]
     news_merge_files = NEWS
+    news_merge_files:policy = recurse
 
 The news_merge_files config option takes a list of file paths, separated by
 commas.

=== modified file 'bzrlib/progress.py'
--- bzrlib/progress.py	2010-04-30 11:03:59 +0000
+++ bzrlib/progress.py	2010-02-25 06:42:33 +0000
@@ -27,7 +27,12 @@
 import os
 
 
+from bzrlib import (
+    errors,
+    )
+from bzrlib.trace import mutter
 from bzrlib.symbol_versioning import (
+    deprecated_function,
     deprecated_in,
     deprecated_method,
     )

=== modified file 'bzrlib/push.py'
--- bzrlib/push.py	2010-04-30 11:03:59 +0000
+++ bzrlib/push.py	2010-02-16 16:08:40 +0000
@@ -17,6 +17,8 @@
 """UI helper for the push command."""
 
 from bzrlib import (
+    builtins,
+    branch,
     bzrdir,
     errors,
     revision as _mod_revision,

=== modified file 'bzrlib/reconcile.py'
--- bzrlib/reconcile.py	2010-04-30 11:35:43 +0000
+++ bzrlib/reconcile.py	2010-02-17 17:11:16 +0000
@@ -30,6 +30,7 @@
     cleanup,
     errors,
     ui,
+    repository,
     )
 from bzrlib.trace import mutter
 from bzrlib.tsort import topo_sort
@@ -96,7 +97,7 @@
     def _reconcile_repository(self):
         self.repo = self.bzrdir.find_repository()
         ui.ui_factory.note('Reconciling repository %s' %
-            self.repo.user_url)
+            self.repo.bzrdir.root_transport.base)
         self.pb.update("Reconciling repository", 0, 1)
         repo_reconciler = self.repo.reconcile(thorough=True)
         self.inconsistent_parents = repo_reconciler.inconsistent_parents

=== modified file 'bzrlib/reconfigure.py'
--- bzrlib/reconfigure.py	2010-04-23 00:44:15 +0000
+++ bzrlib/reconfigure.py	2010-03-25 09:39:03 +0000
@@ -82,13 +82,14 @@
             self.repository = None
             self.local_repository = None
         else:
-            if (self.repository.user_url == self.bzrdir.user_url):
+            if (self.repository.bzrdir.root_transport.base ==
+                self.bzrdir.root_transport.base):
                 self.local_repository = self.repository
             else:
                 self.local_repository = None
         try:
             branch = self.bzrdir.open_branch()
-            if branch.user_url == bzrdir.user_url:
+            if branch.bzrdir.root_transport.base == bzrdir.root_transport.base:
                 self.local_branch = branch
                 self.referenced_branch = None
             else:
@@ -216,8 +217,8 @@
             if not want_reference:
                 self._create_repository = True
         else:
-            if want_reference and (
-                self.repository.user_url == self.bzrdir.user_url):
+            if want_reference and (self.repository.bzrdir.root_transport.base
+                                   == self.bzrdir.root_transport.base):
                 if not self.repository.is_shared():
                     self._destroy_repository = True
         if self.referenced_branch is None:
@@ -343,7 +344,7 @@
             if self._create_reference:
                 reference_branch.repository.fetch(self.repository)
             elif self.local_branch is not None and not self._destroy_branch:
-                up = self.local_branch.user_transport.clone('..')
+                up = self.local_branch.bzrdir.root_transport.clone('..')
                 up_bzrdir = bzrdir.BzrDir.open_containing_from_transport(up)[0]
                 new_repo = up_bzrdir.find_repository()
                 new_repo.fetch(self.repository)

=== modified file 'bzrlib/remote.py'
--- bzrlib/remote.py	2010-05-03 04:08:50 +0000
+++ bzrlib/remote.py	2010-04-20 04:16:50 +0000
@@ -643,8 +643,7 @@
         return self._custom_format._serializer
 
 
-class RemoteRepository(_RpcHelper, lock._RelockDebugMixin,
-    bzrdir.ControlComponent):
+class RemoteRepository(_RpcHelper, lock._RelockDebugMixin):
     """Repository accessed over rpc.
 
     For the moment most operations are performed using local transport-backed
@@ -693,17 +692,6 @@
         # Additional places to query for data.
         self._fallback_repositories = []
 
-    @property
-    def user_transport(self):
-        return self.bzrdir.user_transport
-
-    @property
-    def control_transport(self):
-        # XXX: Normally you shouldn't directly get at the remote repository
-        # transport, but I'm not sure it's worth making this method
-        # optional -- mbp 2010-04-21
-        return self.bzrdir.get_repository_transport(None)
-        
     def __str__(self):
         return "%s(%s)" % (self.__class__.__name__, self.base)
 
@@ -1246,9 +1234,9 @@
         # _real_branch had its get_stacked_on_url method called), then the
         # repository to be added may already be in the _real_repositories list.
         if self._real_repository is not None:
-            fallback_locations = [repo.user_url for repo in
+            fallback_locations = [repo.bzrdir.root_transport.base for repo in
                 self._real_repository._fallback_repositories]
-            if repository.user_url not in fallback_locations:
+            if repository.bzrdir.root_transport.base not in fallback_locations:
                 self._real_repository.add_fallback_repository(repository)
 
     def _check_fallback_repository(self, repository):
@@ -2193,8 +2181,7 @@
             self._real_branch = None
         # Fill out expected attributes of branch for bzrlib API users.
         self._clear_cached_state()
-        # TODO: deprecate self.base in favor of user_url
-        self.base = self.bzrdir.user_url
+        self.base = self.bzrdir.root_transport.base
         self._name = name
         self._control_files = None
         self._lock_mode = None

=== modified file 'bzrlib/repofmt/weaverepo.py'
--- bzrlib/repofmt/weaverepo.py	2010-04-28 07:03:38 +0000
+++ bzrlib/repofmt/weaverepo.py	2010-04-26 13:51:08 +0000
@@ -177,7 +177,7 @@
         :param new_value: True to restore the default, False to disable making
                           working trees.
         """
-        raise errors.RepositoryUpgradeRequired(self.user_url)
+        raise errors.RepositoryUpgradeRequired(self.bzrdir.root_transport.base)
 
     def make_working_trees(self):
         """Returns the policy for making working trees on new branches."""

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2010-04-28 07:03:38 +0000
+++ bzrlib/repository.py	2010-04-22 17:08:27 +0000
@@ -864,7 +864,7 @@
 # Repositories
 
 
-class Repository(_RelockDebugMixin, bzrdir.ControlComponent):
+class Repository(_RelockDebugMixin):
     """Repository holding history for one or more branches.
 
     The repository holds and retrieves historical information including
@@ -1291,10 +1291,11 @@
 
         :param _format: The format of the repository on disk.
         :param a_bzrdir: The BzrDir of the repository.
+
+        In the future we will have a single api for all stores for
+        getting file texts, inventories and revisions, then
+        this construct will accept instances of those things.
         """
-        # In the future we will have a single api for all stores for
-        # getting file texts, inventories and revisions, then
-        # this construct will accept instances of those things.
         super(Repository, self).__init__()
         self._format = _format
         # the following are part of the public API for Repository:
@@ -1315,14 +1316,6 @@
         # rather copying them?
         self._safe_to_return_from_cache = False
 
-    @property
-    def user_transport(self):
-        return self.bzrdir.user_transport
-
-    @property
-    def control_transport(self):
-        return self._transport
-
     def __repr__(self):
         if self._fallback_repositories:
             return '%s(%r, fallback_repositories=%r)' % (
@@ -1476,7 +1469,7 @@
 
         # now gather global repository information
         # XXX: This is available for many repos regardless of listability.
-        if self.user_transport.listable():
+        if self.bzrdir.root_transport.listable():
             # XXX: do we want to __define len__() ?
             # Maybe the versionedfiles object should provide a different
             # method to get the number of keys.
@@ -1514,7 +1507,7 @@
 
         ret = []
         for branches, repository in bzrdir.BzrDir.find_bzrdirs(
-                self.user_transport, evaluate=Evaluator()):
+                self.bzrdir.root_transport, evaluate=Evaluator()):
             if branches is not None:
                 ret.extend(branches)
             if not using and repository is not None:

=== modified file 'bzrlib/revisiontree.py'
--- bzrlib/revisiontree.py	2010-04-30 11:03:59 +0000
+++ bzrlib/revisiontree.py	2010-02-17 17:11:16 +0000
@@ -20,7 +20,9 @@
 
 from bzrlib import (
     errors,
+    osutils,
     revision,
+    symbol_versioning,
     tree,
     )
 

=== modified file 'bzrlib/send.py'
--- bzrlib/send.py	2010-04-22 14:18:17 +0000
+++ bzrlib/send.py	2010-04-12 16:54:35 +0000
@@ -111,10 +111,8 @@
                 base_revision_id = revision[0].as_revision_id(branch)
         if revision_id is None:
             if tree is not None:
-                tree.check_changed_or_out_of_date(
-                    strict, 'send_strict',
-                    more_error='Use --no-strict to force the send.',
-                    more_warning='Uncommitted changes will not be sent.')
+                tree.warn_if_changed_or_out_of_date(
+                    strict, 'send_strict', 'Use --no-strict to force the send.')
             revision_id = branch.last_revision()
         if revision_id == NULL_REVISION:
             raise errors.BzrCommandError('No revisions to submit.')

=== modified file 'bzrlib/shelf.py'
--- bzrlib/shelf.py	2010-04-30 11:03:59 +0000
+++ bzrlib/shelf.py	2009-09-11 07:55:48 +0000
@@ -23,8 +23,11 @@
     errors,
     merge,
     merge3,
+    osutils,
     pack,
     transform,
+    ui,
+    workingtree,
 )
 
 

=== modified file 'bzrlib/smart/bzrdir.py'
--- bzrlib/smart/bzrdir.py	2010-04-23 00:44:15 +0000
+++ bzrlib/smart/bzrdir.py	2010-02-17 17:11:16 +0000
@@ -110,7 +110,7 @@
         """Get the relative path for repository from current_transport."""
         # the relpath of the bzrdir in the found repository gives us the
         # path segments to pop-out.
-        relpath = repository.user_transport.relpath(
+        relpath = repository.bzrdir.root_transport.relpath(
             current_transport.base)
         if len(relpath):
             segments = ['..'] * len(relpath.split('/'))

=== modified file 'bzrlib/smart/medium.py'
--- bzrlib/smart/medium.py	2010-05-03 04:08:50 +0000
+++ bzrlib/smart/medium.py	2010-03-18 23:11:15 +0000
@@ -607,16 +607,10 @@
             # which is newer than a previously supplied older-than version.
             # This indicates that some smart verb call is not guarded
             # appropriately (it should simply not have been tried).
-            trace.mutter(
+            raise AssertionError(
                 "_remember_remote_is_before(%r) called, but "
                 "_remember_remote_is_before(%r) was called previously."
-                , version_tuple, self._remote_version_is_before)
-            if 'hpss' in debug.debug_flags:
-                ui.ui_factory.show_warning(
-                    "_remember_remote_is_before(%r) called, but "
-                    "_remember_remote_is_before(%r) was called previously."
-                    % (version_tuple, self._remote_version_is_before))
-            return
+                % (version_tuple, self._remote_version_is_before))
         self._remote_version_is_before = version_tuple
 
     def protocol_version(self):

=== modified file 'bzrlib/status.py'
--- bzrlib/status.py	2010-04-30 11:35:43 +0000
+++ bzrlib/status.py	2010-04-15 20:22:04 +0000
@@ -20,10 +20,14 @@
     delta as _mod_delta,
     log,
     osutils,
+    tree,
     tsort,
     revision as _mod_revision,
     )
 import bzrlib.errors as errors
+from bzrlib.osutils import is_inside_any
+from bzrlib.symbol_versioning import (deprecated_function,
+        )
 from bzrlib.trace import mutter, warning
 
 # TODO: when showing single-line logs, truncate to the width of the terminal

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2010-05-06 07:48:22 +0000
+++ bzrlib/tests/__init__.py	2010-04-23 08:51:52 +0000
@@ -3201,19 +3201,6 @@
     return result
 
 
-def workaround_zealous_crypto_random():
-    """Crypto.Random want to help us being secure, but we don't care here.
-
-    This workaround some test failure related to the sftp server. Once paramiko
-    stop using the controversial API in Crypto.Random, we may get rid of it.
-    """
-    try:
-        from Crypto.Random import atfork
-        atfork()
-    except ImportError:
-        pass
-
-
 def fork_for_tests(suite):
     """Take suite and start up one runner per CPU by forking()
 
@@ -3243,7 +3230,6 @@
         c2pread, c2pwrite = os.pipe()
         pid = os.fork()
         if pid == 0:
-            workaround_zealous_crypto_random()
             try:
                 os.close(c2pread)
                 # Leave stderr and stdout open so we can see test noise
@@ -3734,7 +3720,6 @@
         'bzrlib.tests.test_lru_cache',
         'bzrlib.tests.test_lsprof',
         'bzrlib.tests.test_mail_client',
-        'bzrlib.tests.test_matchers',
         'bzrlib.tests.test_memorytree',
         'bzrlib.tests.test_merge',
         'bzrlib.tests.test_merge3',

=== modified file 'bzrlib/tests/blackbox/test_dpush.py'
--- bzrlib/tests/blackbox/test_dpush.py	2010-04-28 10:30:48 +0000
+++ bzrlib/tests/blackbox/test_dpush.py	2010-04-13 06:42:19 +0000
@@ -153,6 +153,24 @@
         conf.set_user_option('dpush_strict', value)
 
     _default_command = ['dpush', '../to']
+    _default_pushed_revid = False # Doesn't aplly for dpush
+
+    def assertPushSucceeds(self, args, pushed_revid=None, with_warning=False):
+        if with_warning:
+            error_regexes = self._default_errors
+        else:
+            error_regexes = []
+        self.run_bzr(self._default_command + args,
+                     working_dir=self._default_wd, error_regexes=error_regexes)
+        if pushed_revid is None:
+            # dpush change the revids, so we need to get back to it
+            branch_from = branch.Branch.open(self._default_wd)
+            pushed_revid = branch_from.last_revision()
+        branch_to = branch.Branch.open('to')
+        repo_to = branch_to.repository
+        self.assertTrue(repo_to.has_revision(pushed_revid))
+        self.assertEqual(branch_to.last_revision(), pushed_revid)
+
 
 
 class TestDpushStrictWithoutChanges(TestDpushStrictMixin,

=== modified file 'bzrlib/tests/blackbox/test_filesystem_cicp.py'
--- bzrlib/tests/blackbox/test_filesystem_cicp.py	2010-04-28 07:53:34 +0000
+++ bzrlib/tests/blackbox/test_filesystem_cicp.py	2009-08-26 09:06:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,8 +19,6 @@
 
 import os
 
-from bzrlib import (osutils,
-    )
 from bzrlib.tests.blackbox import ExternalBase
 from bzrlib.tests import CaseInsCasePresFilenameFeature, KnownFailure
 from bzrlib.osutils import canonical_relpath, pathjoin
@@ -91,7 +89,7 @@
         self.build_tree(['MixedCase'])
         self.check_output('adding MixedCase\n', 'add MixedCase')
         # 'accidently' rename the file on disk
-        osutils.rename('MixedCase', 'mixedcase')
+        os.rename('MixedCase', 'mixedcase')
         self.check_empty_output('add mixedcase')
 
     def test_re_add_dir(self):
@@ -105,7 +103,7 @@
                           'adding MixedCaseParent/MixedCase\n',
                           'add MixedCaseParent')
         # 'accidently' rename the directory on disk
-        osutils.rename('MixedCaseParent', 'mixedcaseparent')
+        os.rename('MixedCaseParent', 'mixedcaseparent')
         self.check_empty_output('add mixedcaseparent')
 
     def test_add_not_found(self):
@@ -132,7 +130,7 @@
         wt = self._make_mixed_case_tree()
         self.run_bzr('add')
         self.run_bzr('ci -m message')
-        osutils.rename('CamelCaseParent/CamelCase', 'CamelCaseParent/NewCamelCase')
+        os.rename('CamelCaseParent/CamelCase', 'CamelCaseParent/NewCamelCase')
 
         # In this case we can specify the incorrect case for the destination,
         # as we use --after, so the file-system is sniffed.
@@ -159,7 +157,7 @@
         # Remove the source and create a destination file on disk with a different case.
         # bzr should report that the filename is already versioned.
         os.unlink('CamelCaseParent/CamelCase')
-        osutils.rename('lowercaseparent/lowercase', 'lowercaseparent/LOWERCASE')
+        os.rename('lowercaseparent/lowercase', 'lowercaseparent/LOWERCASE')
         ex = 'bzr: ERROR: Could not move CamelCase => lowercase: lowercaseparent/lowercase is already versioned.\n'
         self.check_error_output(3, ex, 'mv --after camelcaseparent/camelcase LOWERCASEPARENT/LOWERCASE')
 
@@ -175,7 +173,7 @@
         wt = self._make_mixed_case_tree()
         self.run_bzr('add')
         self.run_bzr('ci -m message')
-        osutils.rename('CamelCaseParent', 'NewCamelCaseParent')
+        os.rename('CamelCaseParent', 'NewCamelCaseParent')
 
         # In this case we can specify the incorrect case for the destination,
         # as we use --after, so the file-system is sniffed.
@@ -201,7 +199,7 @@
 
         # perform a mv to the new case - we must ensure the file-system has the
         # new case first.
-        osutils.rename('CamelCaseParent/CamelCase', 'CamelCaseParent/camelCase')
+        os.rename('CamelCaseParent/CamelCase', 'CamelCaseParent/camelCase')
         self.check_output('CamelCaseParent/CamelCase => CamelCaseParent/camelCase\n',
                           'mv --after camelcaseparent/camelcase camelcaseparent/camelCase')
         # bzr should not have renamed the file to a different case

=== modified file 'bzrlib/tests/blackbox/test_join.py'
--- bzrlib/tests/blackbox/test_join.py	2010-04-28 07:53:34 +0000
+++ bzrlib/tests/blackbox/test_join.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,13 +17,7 @@
 
 import os
 
-from bzrlib import (
-    bzrdir,
-    osutils,
-    repository,
-    tests,
-    workingtree,
-    )
+from bzrlib import bzrdir, repository, tests, workingtree
 
 
 class TestJoin(tests.TestCaseWithTransport):
@@ -56,7 +50,7 @@
     def test_join_error(self):
         base_tree, sub_tree = self.make_trees()
         os.mkdir('tree/subtree2')
-        osutils.rename('tree/subtree', 'tree/subtree2/subtree')
+        os.rename('tree/subtree', 'tree/subtree2/subtree')
         self.run_bzr_error(
             ('Cannot join .*subtree.  Parent directory is not versioned',),
              'join tree/subtree2/subtree')

=== modified file 'bzrlib/tests/blackbox/test_log.py'
--- bzrlib/tests/blackbox/test_log.py	2010-04-14 12:30:17 +0000
+++ bzrlib/tests/blackbox/test_log.py	2010-03-24 14:15:01 +0000
@@ -365,18 +365,6 @@
                             'options are "utc", "original", "local".'],
                            ['log', '--timezone', 'foo'])
 
-    def test_log_exclude_ancestry_no_range(self):
-        self.make_linear_branch()
-        self.run_bzr_error(['bzr: ERROR: --exclude-common-ancestry'
-                            ' requires -r with two revisions'],
-                           ['log', '--exclude-common-ancestry'])
-
-    def test_log_exclude_ancestry_single_revision(self):
-        self.make_merged_branch()
-        self.run_bzr_error(['bzr: ERROR: --exclude-common-ancestry'
-                            ' requires two different revisions'],
-                           ['log', '--exclude-common-ancestry',
-                            '-r1.1.1..1.1.1'])
 
 class TestLogTags(TestLog):
 

=== modified file 'bzrlib/tests/blackbox/test_push.py'
--- bzrlib/tests/blackbox/test_push.py	2010-04-28 10:30:48 +0000
+++ bzrlib/tests/blackbox/test_push.py	2010-04-15 06:47:06 +0000
@@ -661,35 +661,27 @@
     _default_wd = 'local'
     _default_errors = ['Working tree ".*/local/" has uncommitted '
                        'changes \(See bzr status\)\.',]
-    _default_additional_error = 'Use --no-strict to force the push.\n'
-    _default_additional_warning = 'Uncommitted changes will not be pushed.'
-
+    _default_pushed_revid = 'modified'
 
     def assertPushFails(self, args):
-        out, err = self.run_bzr_error(self._default_errors,
-                                      self._default_command + args,
-                                      working_dir=self._default_wd, retcode=3)
-        self.assertContainsRe(err, self._default_additional_error)
+        ret = self.run_bzr_error(self._default_errors,
+                                 self._default_command + args,
+                                 working_dir=self._default_wd, retcode=3)
 
-    def assertPushSucceeds(self, args, with_warning=False, revid_to_push=None):
+    def assertPushSucceeds(self, args, pushed_revid=None, with_warning=False):
         if with_warning:
             error_regexes = self._default_errors
         else:
             error_regexes = []
-        out, err = self.run_bzr(self._default_command + args,
-                                working_dir=self._default_wd,
-                                error_regexes=error_regexes)
-        if with_warning:
-            self.assertContainsRe(err, self._default_additional_warning)
-        else:
-            self.assertNotContainsRe(err, self._default_additional_warning)
-        branch_from = branch.Branch.open(self._default_wd)
-        if revid_to_push is None:
-            revid_to_push = branch_from.last_revision()
-        branch_to = branch.Branch.open('to')
-        repo_to = branch_to.repository
-        self.assertTrue(repo_to.has_revision(revid_to_push))
-        self.assertEqual(revid_to_push, branch_to.last_revision())
+        ret = self.run_bzr(self._default_command + args,
+                           working_dir=self._default_wd,
+                           error_regexes=error_regexes)
+        if pushed_revid is None:
+            pushed_revid = self._default_pushed_revid
+        tree_to = workingtree.WorkingTree.open('to')
+        repo_to = tree_to.branch.repository
+        self.assertTrue(repo_to.has_revision(pushed_revid))
+        self.assertEqual(tree_to.branch.last_revision_info()[1], pushed_revid)
 
 
 
@@ -756,12 +748,13 @@
         self._default_wd = 'checkout'
         self._default_errors = ["Working tree is out of date, please run"
                                 " 'bzr update'\.",]
+        self._default_pushed_revid = 'modified-in-local'
 
     def test_push_default(self):
         self.assertPushSucceeds([], with_warning=True)
 
     def test_push_with_revision(self):
-        self.assertPushSucceeds(['-r', 'revid:added'], revid_to_push='added')
+        self.assertPushSucceeds(['-r', 'revid:added'], pushed_revid='added')
 
     def test_push_no_strict(self):
         self.assertPushSucceeds(['--no-strict'])

=== modified file 'bzrlib/tests/blackbox/test_send.py'
--- bzrlib/tests/blackbox/test_send.py	2010-04-28 10:30:48 +0000
+++ bzrlib/tests/blackbox/test_send.py	2010-04-12 16:41:03 +0000
@@ -307,8 +307,6 @@
     _default_sent_revs = ['local']
     _default_errors = ['Working tree ".*/local/" has uncommitted '
                        'changes \(See bzr status\)\.',]
-    _default_additional_error = 'Use --no-strict to force the send.\n'
-    _default_additional_warning = 'Uncommitted changes will not be sent.'
 
     def set_config_send_strict(self, value):
         # set config var (any of bazaar.conf, locations.conf, branch.conf
@@ -317,8 +315,7 @@
         conf.set_user_option('send_strict', value)
 
     def assertSendFails(self, args):
-        out, err = self.run_send(args, rc=3, err_re=self._default_errors)
-        self.assertContainsRe(err, self._default_additional_error)
+        self.run_send(args, rc=3, err_re=self._default_errors)
 
     def assertSendSucceeds(self, args, revs=None, with_warning=False):
         if with_warning:
@@ -330,7 +327,6 @@
         out, err = self.run_send(args, err_re=err_re)
         bundling_revs = 'Bundling %d revision(s).\n' % len(revs)
         if with_warning:
-            self.assertContainsRe(err, self._default_additional_warning)
             self.assertEndsWith(err, bundling_revs)
         else:
             self.assertEquals(bundling_revs, err)

=== modified file 'bzrlib/tests/blackbox/test_switch.py'
--- bzrlib/tests/blackbox/test_switch.py	2010-04-28 07:53:34 +0000
+++ bzrlib/tests/blackbox/test_switch.py	2010-03-26 07:08:56 +0000
@@ -20,7 +20,6 @@
 
 import os
 
-from bzrlib import osutils
 from bzrlib.workingtree import WorkingTree
 from bzrlib.tests.blackbox import ExternalBase
 from bzrlib.directory_service import directories
@@ -168,7 +167,7 @@
     def prepare_lightweight_switch(self):
         branch = self.make_branch('branch')
         branch.create_checkout('tree', lightweight=True)
-        osutils.rename('branch', 'branch1')
+        os.rename('branch', 'branch1')
 
     def test_switch_lightweight_after_branch_moved(self):
         self.prepare_lightweight_switch()

=== removed file 'bzrlib/tests/matchers.py'
--- bzrlib/tests/matchers.py	2010-05-06 11:08:10 +0000
+++ bzrlib/tests/matchers.py	1970-01-01 00:00:00 +0000
@@ -1,68 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Matchers for bzrlib.
-
-Primarily test support, Matchers are used by self.assertThat in the bzrlib
-test suite. A matcher is a stateful test helper which can be used to determine
-if a passed object 'matches', much like a regex. If the object does not match
-the mismatch can be described in a human readable fashion. assertThat then
-raises if a mismatch occurs, showing the description as the assertion error.
-
-Matchers are designed to be more reusable and composable than layered
-assertions in Test Case objects, so they are recommended for new testing work.
-"""
-
-__all__ = [
-    'ReturnsUnlockable',
-    ]
-
-from testtools.matchers import Mismatch, Matcher
-
-
-class ReturnsUnlockable(Matcher):
-    """A matcher that checks for the pattern we want lock* methods to have:
-
-    They should return an object with an unlock() method.
-    Calling that method should unlock the original object.
-
-    :ivar lockable_thing: The object which can be locked that will be
-        inspected.
-    """
-
-    def __init__(self, lockable_thing):
-        Matcher.__init__(self)
-        self.lockable_thing = lockable_thing
-
-    def __str__(self):
-        return ('ReturnsUnlockable(lockable_thing=%s)' % 
-            self.lockable_thing)
-
-    def match(self, lock_method):
-        lock_method().unlock()
-        if self.lockable_thing.is_locked():
-            return _IsLocked(self.lockable_thing)
-        return None
-
-
-class _IsLocked(Mismatch):
-    """Something is locked."""
-
-    def __init__(self, lockable_thing):
-        self.lockable_thing = lockable_thing
-
-    def describe(self):
-        return "%s is locked" % self.lockable_thing

=== modified file 'bzrlib/tests/per_branch/test_branch.py'
--- bzrlib/tests/per_branch/test_branch.py	2010-04-21 04:12:25 +0000
+++ bzrlib/tests/per_branch/test_branch.py	2010-03-02 22:25:58 +0000
@@ -988,16 +988,3 @@
         merger.do_merge()
         self.assertEqual('../branch/reference',
                          tree.branch.get_reference_info('file-id')[1])
-
-
-class TestBranchControlComponent(per_branch.TestCaseWithBranch):
-    """Branch implementations adequately implement ControlComponent."""
-    
-    def test_urls(self):
-        br = self.make_branch('branch')
-        self.assertIsInstance(br.user_url, str)
-        self.assertEqual(br.user_url, br.user_transport.base)
-        # for all current bzrdir implementations the user dir must be 
-        # above the control dir but we might need to relax that?
-        self.assertEqual(br.control_url.find(br.user_url), 0)
-        self.assertEqual(br.control_url, br.control_transport.base)

=== modified file 'bzrlib/tests/per_branch/test_iter_merge_sorted_revisions.py'
--- bzrlib/tests/per_branch/test_iter_merge_sorted_revisions.py	2010-04-28 07:10:36 +0000
+++ bzrlib/tests/per_branch/test_iter_merge_sorted_revisions.py	2010-04-02 15:05:24 +0000
@@ -229,37 +229,6 @@
         self.addCleanup(br.unlock)
         return br
 
-    def make_branch_with_alternate_ancestries(self, relpath='.'):
-        # See test_merge_sorted_exclude_ancestry below for the difference with
-        # bt.test_log.TestLogExcludeAncestry.
-        # make_branch_with_alternate_ancestries and
-        # test_merge_sorted_exclude_ancestry
-        # See the FIXME in assertLogRevnos there too.
-        builder = self.make_branch_builder(relpath)
-        # 1
-        # |\
-        # | 1.1.1
-        # | /| \
-        # 2  |  |
-        # |  |  1.2.1
-        # |  | /
-        # |  1.1.2
-        # | /
-        # 3
-        builder.start_series()
-        builder.build_snapshot('1', None, [
-            ('add', ('', 'TREE_ROOT', 'directory', '')),])
-        builder.build_snapshot('1.1.1', ['1'], [])
-        builder.build_snapshot('2', ['1', '1.1.1'], [])
-        builder.build_snapshot('1.2.1', ['1.1.1'], [])
-        builder.build_snapshot('1.1.2', ['1.1.1', '1.2.1'], [])
-        builder.build_snapshot('3', ['2', '1.1.2'], [])
-        builder.finish_series()
-        br = builder.get_branch()
-        br.lock_read()
-        self.addCleanup(br.unlock)
-        return br
-
     def assertIterRevids(self, expected, branch, *args, **kwargs):
         # We don't care about depths and revnos here, only about returning the
         # right revids.
@@ -290,16 +259,3 @@
         self.assertIterRevids(['2.2.1', '2.1.1', '2', '1'],
                               branch, start_revision_id='2.2.1',
                               stop_rule='with-merges')
-
-    def test_merge_sorted_exclude_ancestry(self):
-        branch = self.make_branch_with_alternate_ancestries()
-        self.assertIterRevids(['3', '1.1.2', '1.2.1', '2', '1.1.1', '1'],
-                              branch)
-        # '2' is not part of the ancestry even if merge_sort order will make it
-        # appear before 1.1.1
-        self.assertIterRevids(['1.1.2', '1.2.1'],
-                              branch,
-                              stop_rule='with-merges-without-common-ancestry',
-                              start_revision_id='1.1.2',
-                              stop_revision_id='1.1.1')
-

=== modified file 'bzrlib/tests/per_bzrdir/test_bzrdir.py'
--- bzrlib/tests/per_bzrdir/test_bzrdir.py	2010-04-21 04:02:42 +0000
+++ bzrlib/tests/per_bzrdir/test_bzrdir.py	2010-04-11 19:40:23 +0000
@@ -1971,15 +1971,3 @@
         self.assertRaises(errors.NoRepositoryPresent,
                           made_control.find_repository)
 
-
-class TestBzrDirControlComponent(TestCaseWithBzrDir):
-    """BzrDir implementations adequately implement ControlComponent."""
-    
-    def test_urls(self):
-        bd = self.make_bzrdir('bd')
-        self.assertIsInstance(bd.user_url, str)
-        self.assertEqual(bd.user_url, bd.user_transport.base)
-        # for all current bzrdir implementations the user dir must be 
-        # above the control dir but we might need to relax that?
-        self.assertEqual(bd.control_url.find(bd.user_url), 0)
-        self.assertEqual(bd.control_url, bd.control_transport.base)

=== modified file 'bzrlib/tests/per_repository/test_repository.py'
--- bzrlib/tests/per_repository/test_repository.py	2010-04-21 04:53:33 +0000
+++ bzrlib/tests/per_repository/test_repository.py	2010-04-10 01:22:00 +0000
@@ -1342,18 +1342,3 @@
         fileobj = StringIO()
         wt.branch.repository.create_bundle(
             'rev1', _mod_revision.NULL_REVISION, fileobj)
-
-
-
-
-class TestRepositoryControlComponent(per_repository.TestCaseWithRepository):
-    """Repository implementations adequately implement ControlComponent."""
-    
-    def test_urls(self):
-        repo = self.make_repository('repo')
-        self.assertIsInstance(repo.user_url, str)
-        self.assertEqual(repo.user_url, repo.user_transport.base)
-        # for all current bzrdir implementations the user dir must be 
-        # above the control dir but we might need to relax that?
-        self.assertEqual(repo.control_url.find(repo.user_url), 0)
-        self.assertEqual(repo.control_url, repo.control_transport.base)

=== modified file 'bzrlib/tests/per_repository_chk/__init__.py'
--- bzrlib/tests/per_repository_chk/__init__.py	2010-03-31 16:29:25 +0000
+++ bzrlib/tests/per_repository_chk/__init__.py	2009-09-08 06:25:26 +0000
@@ -27,6 +27,7 @@
     repository,
     remote,
     )
+from bzrlib.bzrdir import BzrDir
 from bzrlib.repofmt.pack_repo import (
     RepositoryFormatKnitPack5,
     )
@@ -35,6 +36,7 @@
     )
 from bzrlib.tests import (
     multiply_tests,
+    TestSuite,
     )
 from bzrlib.tests.per_repository import (
     all_repository_format_scenarios,

=== modified file 'bzrlib/tests/per_repository_reference/__init__.py'
--- bzrlib/tests/per_repository_reference/__init__.py	2010-05-03 04:08:50 +0000
+++ bzrlib/tests/per_repository_reference/__init__.py	2010-04-16 06:51:59 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd
+# Copyright (C) 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/per_repository_reference/test_default_stacking.py'
--- bzrlib/tests/per_repository_reference/test_default_stacking.py	2010-05-03 04:08:50 +0000
+++ bzrlib/tests/per_repository_reference/test_default_stacking.py	2010-04-26 13:51:08 +0000
@@ -15,10 +15,10 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 
-from bzrlib.tests.per_repository import TestCaseWithRepository
-
-
-class TestDefaultStackingPolicy(TestCaseWithRepository):
+from bzrlib.tests import per_repository
+
+
+class TestDefaultStackingPolicy(per_repository.TestCaseWithRepository):
 
     def test_sprout_to_smart_server_stacking_policy_handling(self):
         """Obey policy where possible, ignore otherwise."""

=== modified file 'bzrlib/tests/per_workingtree/test_workingtree.py'
--- bzrlib/tests/per_workingtree/test_workingtree.py	2010-04-21 09:41:26 +0000
+++ bzrlib/tests/per_workingtree/test_workingtree.py	2010-03-02 22:25:58 +0000
@@ -1091,16 +1091,3 @@
         # We should display the relative path
         self.assertEqual('subdir/m\xb5', e.filename)
         self.assertEqual(osutils._fs_enc, e.fs_encoding)
-
-
-class TestControlComponent(TestCaseWithWorkingTree):
-    """WorkingTree implementations adequately implement ControlComponent."""
-    
-    def test_urls(self):
-        wt = self.make_branch_and_tree('wt')
-        self.assertIsInstance(wt.user_url, str)
-        self.assertEqual(wt.user_url, wt.user_transport.base)
-        # for all current bzrdir implementations the user dir must be 
-        # above the control dir but we might need to relax that?
-        self.assertEqual(wt.control_url.find(wt.user_url), 0)
-        self.assertEqual(wt.control_url, wt.control_transport.base)

=== modified file 'bzrlib/tests/test_foreign.py'
--- bzrlib/tests/test_foreign.py	2010-04-23 00:44:15 +0000
+++ bzrlib/tests/test_foreign.py	2010-03-02 22:25:58 +0000
@@ -90,7 +90,6 @@
         self._format = _format
         self._base = a_bzrdir.transport.base
         self._ignore_fallbacks = False
-        self.bzrdir = a_bzrdir
         foreign.ForeignBranch.__init__(self, 
             DummyForeignVcsMapping(DummyForeignVcs()))
         branch.BzrBranch6.__init__(self, _format, _control_files, a_bzrdir, 

=== modified file 'bzrlib/tests/test_log.py'
--- bzrlib/tests/test_log.py	2010-04-28 07:10:36 +0000
+++ bzrlib/tests/test_log.py	2010-03-25 08:14:04 +0000
@@ -18,7 +18,6 @@
 from cStringIO import StringIO
 
 from bzrlib import (
-    branchbuilder,
     errors,
     log,
     registry,
@@ -1542,62 +1541,3 @@
 
     def test_bugs_handler_present(self):
         self.properties_handler_registry.get('bugs_properties_handler')
-
-class TestLogExcludeAncestry(tests.TestCaseWithTransport):
-
-    def make_branch_with_alternate_ancestries(self, relpath='.'):
-        # See test_merge_sorted_exclude_ancestry below for the difference with
-        # bt.per_branch.test_iter_merge_sorted_revision.
-        # TestIterMergeSortedRevisionsBushyGraph. 
-        # make_branch_with_alternate_ancestries
-        # and test_merge_sorted_exclude_ancestry
-        # See the FIXME in assertLogRevnos too.
-        builder = branchbuilder.BranchBuilder(self.get_transport(relpath))
-        # 1
-        # |\
-        # 2 \
-        # |  |
-        # |  1.1.1
-        # |  | \
-        # |  |  1.2.1
-        # |  | /
-        # |  1.1.2
-        # | /
-        # 3
-        builder.start_series()
-        builder.build_snapshot('1', None, [
-            ('add', ('', 'TREE_ROOT', 'directory', '')),])
-        builder.build_snapshot('1.1.1', ['1'], [])
-        builder.build_snapshot('2', ['1'], [])
-        builder.build_snapshot('1.2.1', ['1.1.1'], [])
-        builder.build_snapshot('1.1.2', ['1.1.1', '1.2.1'], [])
-        builder.build_snapshot('3', ['2', '1.1.2'], [])
-        builder.finish_series()
-        br = builder.get_branch()
-        br.lock_read()
-        self.addCleanup(br.unlock)
-        return br
-
-    def assertLogRevnos(self, expected_revnos, b, start, end,
-                        exclude_common_ancestry):
-        # FIXME: the layering in log makes it hard to test intermediate levels,
-        # I wish adding filters with their parameters were easier...
-        # -- vila 20100413
-        iter_revs = log._calc_view_revisions(
-            b, start, end, direction='reverse',
-            generate_merge_revisions=True,
-            exclude_common_ancestry=exclude_common_ancestry)
-        self.assertEqual(expected_revnos,
-                         [revid for revid, revno, depth in iter_revs])
-
-    def test_merge_sorted_exclude_ancestry(self):
-        b = self.make_branch_with_alternate_ancestries()
-        self.assertLogRevnos(['3', '1.1.2', '1.2.1', '1.1.1', '2', '1'],
-                             b, '1', '3', False)
-        # '2' is part of the '3' ancestry but not part of '1.1.1' ancestry so
-        # it should be mentioned even if merge_sort order will make it appear
-        # after 1.1.1
-        self.assertLogRevnos(['3', '1.1.2', '1.2.1', '2'],
-                             b, '1.1.1', '3', True)
-
-

=== removed file 'bzrlib/tests/test_matchers.py'
--- bzrlib/tests/test_matchers.py	2010-05-06 11:08:10 +0000
+++ bzrlib/tests/test_matchers.py	1970-01-01 00:00:00 +0000
@@ -1,64 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests of bzrlib test matchers."""
-
-from testtools.matchers import *
-
-from bzrlib.tests import TestCase
-from bzrlib.tests.matchers import *
-
-
-class StubTree(object):
-    """Stubg for testing."""
-
-    def __init__(self, lock_status):
-        self._is_locked = lock_status
-
-    def __str__(self):
-        return u'I am da tree'
-
-    def is_locked(self):
-        return self._is_locked
-
-
-class FakeUnlockable(object):
-    """Something that can be unlocked."""
-
-    def unlock(self):
-        pass
-
-
-class TestReturnsUnlockable(TestCase):
-
-    def test___str__(self):
-        matcher = ReturnsUnlockable(StubTree(True))
-        self.assertEqual(
-            'ReturnsUnlockable(lockable_thing=I am da tree)',
-            str(matcher))
-
-    def test_match(self):
-        stub_tree = StubTree(False)
-        matcher = ReturnsUnlockable(stub_tree)
-        self.assertThat(matcher.match(lambda:FakeUnlockable()), Equals(None))
-
-    def test_mismatch(self):
-        stub_tree = StubTree(True)
-        matcher = ReturnsUnlockable(stub_tree)
-        mismatch = matcher.match(lambda:FakeUnlockable())
-        self.assertNotEqual(None, mismatch)
-        self.assertThat(mismatch.describe(), Equals("I am da tree is locked"))
-

=== modified file 'bzrlib/tests/test_options.py'
--- bzrlib/tests/test_options.py	2010-04-20 08:47:38 +0000
+++ bzrlib/tests/test_options.py	2009-05-23 21:01:51 +0000
@@ -318,13 +318,6 @@
         self.assertEqual('hello', name)
         self.assertEqual([], value)
 
-    def test_list_option_param_name(self):
-        """Test list options can have their param_name set."""
-        options = [option.ListOption('hello', type=str, param_name='greeting')]
-        opts, args = self.parse(
-            options, ['--hello=world', '--hello=sailor'])
-        self.assertEqual(['world', 'sailor'], opts.greeting)
-
 
 class TestOptionDefinitions(TestCase):
     """Tests for options in the Bazaar codebase."""

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2010-04-27 07:52:08 +0000
+++ bzrlib/tests/test_osutils.py	2010-04-24 13:48:58 +0000
@@ -184,13 +184,6 @@
         shape = sorted(os.listdir('.'))
         self.assertEquals(['A', 'B'], shape)
 
-    def test_rename_error(self):
-        # We wrap os.rename to make it give an error including the filenames
-        # https://bugs.launchpad.net/bzr/+bug/491763
-        err = self.assertRaises(OSError, osutils.rename,
-            'nonexistent', 'target')
-        self.assertContainsString(str(err), 'nonexistent')
-
 
 class TestRandChars(tests.TestCase):
 

=== modified file 'bzrlib/tests/test_remote.py'
--- bzrlib/tests/test_remote.py	2010-05-03 04:08:50 +0000
+++ bzrlib/tests/test_remote.py	2010-04-20 00:20:00 +0000
@@ -418,12 +418,9 @@
         # Calling _remember_remote_is_before again with a lower value works.
         client_medium._remember_remote_is_before((1, 5))
         self.assertTrue(client_medium._is_remote_before((1, 5)))
-        # If you call _remember_remote_is_before with a higher value it logs a
-        # warning, and continues to remember the lower value.
-        self.assertNotContainsRe(self.get_log(), '_remember_remote_is_before')
-        client_medium._remember_remote_is_before((1, 9))
-        self.assertContainsRe(self.get_log(), '_remember_remote_is_before')
-        self.assertTrue(client_medium._is_remote_before((1, 5)))
+        # You cannot call _remember_remote_is_before with a larger value.
+        self.assertRaises(
+            AssertionError, client_medium._remember_remote_is_before, (1, 9))
 
 
 class TestBzrDirCloningMetaDir(TestRemote):
@@ -531,28 +528,6 @@
         self.assertIsInstance(bd, RemoteBzrDir)
         self.assertFinished(client)
 
-    def test_backwards_compat_hpss_v2(self):
-        client, transport = self.make_fake_client_and_transport()
-        # Monkey-patch fake client to simulate real-world behaviour with v2
-        # server: upon first RPC call detect the protocol version, and because
-        # the version is 2 also do _remember_remote_is_before((1, 6)) before
-        # continuing with the RPC.
-        orig_check_call = client._check_call
-        def check_call(method, args):
-            client._medium._protocol_version = 2
-            client._medium._remember_remote_is_before((1, 6))
-            client._check_call = orig_check_call
-            client._check_call(method, args)
-        client._check_call = check_call
-        client.add_expected_call(
-            'BzrDir.open_2.1', ('quack/',), 'unknown', ('BzrDir.open_2.1',))
-        client.add_expected_call(
-            'BzrDir.open', ('quack/',), 'success', ('yes',))
-        bd = RemoteBzrDir(transport, remote.RemoteBzrDirFormat(),
-            _client=client, _force_probe=True)
-        self.assertIsInstance(bd, RemoteBzrDir)
-        self.assertFinished(client)
-
 
 class TestBzrDirOpenBranch(TestRemote):
 

=== modified file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	2010-03-31 16:29:25 +0000
+++ bzrlib/tests/test_repository.py	2010-02-09 21:03:24 +0000
@@ -23,10 +23,12 @@
 """
 
 from stat import S_ISDIR
+from StringIO import StringIO
 import sys
 
 import bzrlib
-from bzrlib.errors import (NoSuchFile,
+from bzrlib.errors import (NotBranchError,
+                           NoSuchFile,
                            UnknownFormatError,
                            UnsupportedFormatError,
                            )
@@ -34,23 +36,31 @@
     graph,
     tests,
     )
+from bzrlib.branchbuilder import BranchBuilder
 from bzrlib.btree_index import BTreeBuilder, BTreeGraphIndex
-from bzrlib.index import GraphIndex
+from bzrlib.index import GraphIndex, InMemoryGraphIndex
 from bzrlib.repository import RepositoryFormat
+from bzrlib.smart import server
 from bzrlib.tests import (
     TestCase,
     TestCaseWithTransport,
+    TestSkipped,
+    test_knit,
     )
 from bzrlib.transport import (
+    fakenfs,
     get_transport,
     )
 from bzrlib import (
+    bencode,
     bzrdir,
     errors,
     inventory,
     osutils,
+    progress,
     repository,
     revision as _mod_revision,
+    symbol_versioning,
     upgrade,
     versionedfile,
     workingtree,

=== modified file 'bzrlib/textinv.py'
--- bzrlib/textinv.py	2010-04-30 11:03:59 +0000
+++ bzrlib/textinv.py	2009-03-23 14:59:43 +0000
@@ -16,7 +16,7 @@
 
 
 from bzrlib.errors import BzrError
-from bzrlib.inventory import Inventory
+from bzrlib.inventory import InventoryEntry, Inventory
 
 
 START_MARK = "# bzr inventory format 3\n"

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2010-04-30 11:35:43 +0000
+++ bzrlib/transform.py	2010-04-01 12:53:53 +0000
@@ -35,7 +35,7 @@
     )
 """)
 from bzrlib.errors import (DuplicateKey, MalformedTransform, NoSuchFile,
-                           ReusingTransform, CantMoveRoot,
+                           ReusingTransform, NotVersionedError, CantMoveRoot,
                            ExistingLimbo, ImmortalLimbo, NoFinalPath,
                            UnableCreateSymlink)
 from bzrlib.filters import filtered_output_bytes, ContentFilterContext
@@ -1160,7 +1160,7 @@
             if trans_id not in self._new_contents:
                 continue
             new_path = self._limbo_name(trans_id)
-            osutils.rename(old_path, new_path)
+            os.rename(old_path, new_path)
             for descendant in self._limbo_descendants(trans_id):
                 desc_path = self._limbo_files[descendant]
                 desc_path = new_path + desc_path[len(old_path):]
@@ -2898,9 +2898,9 @@
         self.pending_deletions = []
 
     def rename(self, from_, to):
-        """Rename a file from one path to another."""
+        """Rename a file from one path to another.  Functions like os.rename"""
         try:
-            osutils.rename(from_, to)
+            os.rename(from_, to)
         except OSError, e:
             if e.errno in (errno.EEXIST, errno.ENOTEMPTY):
                 raise errors.FileExists(to, str(e))
@@ -2920,7 +2920,7 @@
     def rollback(self):
         """Reverse all renames that have been performed"""
         for from_, to in reversed(self.past_renames):
-            osutils.rename(to, from_)
+            os.rename(to, from_)
         # after rollback, don't reuse _FileMover
         past_renames = None
         pending_deletions = None

=== modified file 'bzrlib/transport/chroot.py'
--- bzrlib/transport/chroot.py	2010-04-07 12:19:40 +0000
+++ bzrlib/transport/chroot.py	2010-02-23 07:43:11 +0000
@@ -19,8 +19,12 @@
 """
 
 from bzrlib.transport import (
+    get_transport,
     pathfilter,
     register_transport,
+    Server,
+    Transport,
+    unregister_transport,
     )
 
 

=== modified file 'bzrlib/transport/local.py'
--- bzrlib/transport/local.py	2010-04-28 07:53:34 +0000
+++ bzrlib/transport/local.py	2010-03-11 04:18:33 +0000
@@ -399,18 +399,13 @@
 
     def rename(self, rel_from, rel_to):
         path_from = self._abspath(rel_from)
-        path_to = self._abspath(rel_to)
         try:
             # *don't* call bzrlib.osutils.rename, because we want to
-            # detect conflicting names on rename, and osutils.rename tries to
-            # mask cross-platform differences there; however we do update the
-            # exception to include the filenames
-            os.rename(path_from, path_to)
+            # detect errors on rename
+            os.rename(path_from, self._abspath(rel_to))
         except (IOError, OSError),e:
             # TODO: What about path_to?
-            self._translate_error(
-                osutils._add_rename_error_details(e, path_from, path_to),
-                path_from)
+            self._translate_error(e, path_from)
 
     def move(self, rel_from, rel_to):
         """Move the item at rel_from to the location at rel_to"""

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2010-04-30 11:03:59 +0000
+++ bzrlib/tree.py	2010-02-17 05:12:01 +0000
@@ -36,6 +36,7 @@
 from bzrlib.inventory import InventoryFile
 from bzrlib.inter import InterObject
 from bzrlib.osutils import fingerprint_file
+import bzrlib.revision
 from bzrlib.symbol_versioning import deprecated_function, deprecated_in
 from bzrlib.trace import note
 

=== modified file 'bzrlib/uncommit.py'
--- bzrlib/uncommit.py	2010-04-30 11:03:59 +0000
+++ bzrlib/uncommit.py	2009-03-23 14:59:43 +0000
@@ -18,6 +18,8 @@
 
 # TODO: make the guts of this methods on tree, branch.
 
+import os
+
 from bzrlib import (
     errors,
     revision as _mod_revision,

=== modified file 'bzrlib/upgrade.py'
--- bzrlib/upgrade.py	2010-04-21 11:27:04 +0000
+++ bzrlib/upgrade.py	2010-03-25 07:34:15 +0000
@@ -47,10 +47,11 @@
     def convert(self):
         try:
             branch = self.bzrdir.open_branch()
-            if branch.user_url != self.bzrdir.user_url:
+            if branch.bzrdir.root_transport.base != \
+                self.bzrdir.root_transport.base:
                 ui.ui_factory.note("This is a checkout. The branch (%s) needs to be "
                              "upgraded separately." %
-                             branch.user_url)
+                             branch.bzrdir.root_transport.base)
             del branch
         except (errors.NotBranchError, errors.IncompatibleRepositories):
             # might not be a format we can open without upgrading; see e.g.

=== modified file 'bzrlib/version.py'
--- bzrlib/version.py	2010-04-30 11:03:59 +0000
+++ bzrlib/version.py	2010-02-23 07:43:11 +0000
@@ -27,6 +27,7 @@
     osutils,
     trace,
     )
+from bzrlib.branch import Branch
 
 
 def show_version(show_config=True, show_copyright=True, to_file=None):

=== modified file 'bzrlib/versionedfile.py'
--- bzrlib/versionedfile.py	2010-04-30 11:03:59 +0000
+++ bzrlib/versionedfile.py	2010-02-17 17:11:16 +0000
@@ -45,6 +45,7 @@
 from bzrlib.graph import DictParentsProvider, Graph, StackedParentsProvider
 from bzrlib.transport.memory import MemoryTransport
 """)
+from bzrlib.inter import InterObject
 from bzrlib.registry import Registry
 from bzrlib.symbol_versioning import *
 from bzrlib.textmerge import TextMerge

=== modified file 'bzrlib/weave.py'
--- bzrlib/weave.py	2010-04-30 11:03:59 +0000
+++ bzrlib/weave.py	2009-06-10 03:56:49 +0000
@@ -69,6 +69,8 @@
 from copy import copy
 from cStringIO import StringIO
 import os
+import time
+import warnings
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
@@ -77,11 +79,14 @@
 from bzrlib import (
     errors,
     osutils,
+    progress,
     )
 from bzrlib.errors import (WeaveError, WeaveFormatError, WeaveParentMismatch,
         RevisionAlreadyPresent,
         RevisionNotPresent,
         UnavailableRepresentation,
+        WeaveRevisionAlreadyPresent,
+        WeaveRevisionNotPresent,
         )
 from bzrlib.osutils import dirname, sha, sha_strings, split_lines
 import bzrlib.patiencediff

=== modified file 'bzrlib/win32utils.py'
--- bzrlib/win32utils.py	2010-04-30 11:03:59 +0000
+++ bzrlib/win32utils.py	2010-02-23 07:43:11 +0000
@@ -21,6 +21,7 @@
 
 import glob
 import os
+import re
 import struct
 import sys
 

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2010-04-30 11:35:43 +0000
+++ bzrlib/workingtree.py	2010-04-08 06:05:44 +0000
@@ -29,6 +29,12 @@
 WorkingTree.open(dir).
 """
 
+# TODO: Give the workingtree sole responsibility for the working inventory;
+# remove the variable and references to it from the branch.  This may require
+# updating the commit code so as to update the inventory within the working
+# copy, and making sure there's only one WorkingTree for any directory on disk.
+# At the moment they may alias the inventory and have old copies of it in
+# memory.  (Now done? -- mbp 20060309)
 
 from cStringIO import StringIO
 import os
@@ -95,6 +101,7 @@
 from bzrlib.filters import filtered_input_file
 from bzrlib.trace import mutter, note
 from bzrlib.transport.local import LocalTransport
+from bzrlib.progress import ProgressPhase
 from bzrlib.revision import CURRENT_REVISION
 from bzrlib.rio import RioReader, rio_file, Stanza
 from bzrlib.symbol_versioning import (
@@ -167,8 +174,7 @@
         return ''
 
 
-class WorkingTree(bzrlib.mutabletree.MutableTree,
-    bzrdir.ControlComponent):
+class WorkingTree(bzrlib.mutabletree.MutableTree):
     """Working copy tree.
 
     The inventory is held in the `Branch` working-inventory, and the
@@ -247,14 +253,6 @@
         self._rules_searcher = None
         self.views = self._make_views()
 
-    @property
-    def user_transport(self):
-        return self.bzrdir.user_transport
-
-    @property
-    def control_transport(self):
-        return self._transport
-
     def _detect_case_handling(self):
         wt_trans = self.bzrdir.get_workingtree_transport(None)
         try:

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2010-04-30 11:03:59 +0000
+++ bzrlib/workingtree_4.py	2010-03-10 09:31:25 +0000
@@ -53,6 +53,7 @@
 from bzrlib.decorators import needs_read_lock, needs_write_lock
 from bzrlib.filters import filtered_input_file, internal_size_sha_file_byname
 from bzrlib.inventory import Inventory, ROOT_ID, entry_factory
+import bzrlib.mutabletree
 from bzrlib.mutabletree import needs_tree_write_lock
 from bzrlib.osutils import (
     file_kind,

=== modified file 'bzrlib/xml4.py'
--- bzrlib/xml4.py	2010-04-30 11:03:59 +0000
+++ bzrlib/xml4.py	2010-02-17 17:11:16 +0000
@@ -16,11 +16,12 @@
 
 from bzrlib.xml_serializer import (
     Element,
+    ElementTree,
     SubElement,
     XMLSerializer,
     escape_invalid_chars,
     )
-from bzrlib.inventory import ROOT_ID, Inventory
+from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
 import bzrlib.inventory as inventory
 from bzrlib.revision import Revision
 from bzrlib.errors import BzrError

=== modified file 'bzrlib/xml8.py'
--- bzrlib/xml8.py	2010-04-30 11:03:59 +0000
+++ bzrlib/xml8.py	2010-02-17 17:11:16 +0000
@@ -30,7 +30,7 @@
     XMLSerializer,
     escape_invalid_chars,
     )
-from bzrlib.inventory import InventoryEntry
+from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
 from bzrlib.revision import Revision
 from bzrlib.errors import BzrError
 

=== modified file 'bzrlib/xml_serializer.py'
--- bzrlib/xml_serializer.py	2010-04-30 11:03:59 +0000
+++ bzrlib/xml_serializer.py	2010-02-17 17:11:16 +0000
@@ -23,7 +23,7 @@
 # ElementTree bits
 
 from bzrlib.serializer import Serializer
-from bzrlib.trace import mutter
+from bzrlib.trace import mutter, warning
 
 try:
     try:

=== modified file 'doc/en/Makefile'
--- doc/en/Makefile	2010-03-25 10:09:32 +0000
+++ doc/en/Makefile	2009-09-08 12:33:30 +0000
@@ -11,22 +11,6 @@
 PAPEROPT_letter = -D latex_paper_size=letter
 ALLSPHINXOPTS   = -d _build/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
 
-# Note that this assumes name of the output dir is same as name of the rule.
-define make_output_dirs
-# Create output directory (only needed for sphinx < 0.5)
-[ -d _build ] || mkdir _build
-[ -d "_build/$@" ] || mkdir "_build/$@"
-# Workaround for a bug in sphinx < 0.5 where it tries to delete
-# nonexistent static dirs and does not catch the exception.  This was
-# fixed in svn+ssh://pythondev@svn.python.org/doctools/branches/0.4.x
-# at r65551 and merged as 280b62246342 in hg branch released as 0.5.
-[ -d "_build/$@/_static" ] || mkdir "_build/$@/_static"
-for fn in _static/*; do \
-    [ ! -d "$$fn" ] && continue; \
-    [ -d "_build/$@/$$fn" ] || mkdir "_build/$@/$$fn"; \
-done
-endef
-
 .PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest
 
 help:
@@ -46,38 +30,32 @@
 	-rm -rf _build/*
 
 html:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) _build/html
 	@echo
 	@echo "Build finished. The HTML pages are in _build/html."
 
 dirhtml:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) _build/dirhtml
 	@echo
 	@echo "Build finished. The HTML pages are in _build/dirhtml."
 
 pickle:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) _build/pickle
 	@echo
 	@echo "Build finished; now you can process the pickle files."
 
 json:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) _build/json
 	@echo
 	@echo "Build finished; now you can process the JSON files."
 
 htmlhelp:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) _build/htmlhelp
 	@echo
 	@echo "Build finished; now you can run HTML Help Workshop with the" \
 	      ".hhp project file in _build/htmlhelp."
 
 qthelp:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) _build/qthelp
 	@echo
 	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
@@ -87,7 +65,6 @@
 	@echo "# assistant -collectionFile _build/qthelp/Bazaar.qhc"
 
 latex:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) _build/latex
 	@echo
 	@echo "Build finished; the LaTeX files are in _build/latex."
@@ -95,20 +72,17 @@
 	      "run these through (pdf)latex."
 
 changes:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) _build/changes
 	@echo
 	@echo "The overview file is in _build/changes."
 
 linkcheck:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) _build/linkcheck
 	@echo
 	@echo "Link check complete; look for any errors in the above output " \
 	      "or in _build/linkcheck/output.txt."
 
 doctest:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) _build/doctest
 	@echo "Testing of doctests in the sources finished, look at the " \
 	      "results in _build/doctest/output.txt."

=== modified file 'doc/en/user-guide/hooks.txt'
--- doc/en/user-guide/hooks.txt	2010-04-22 07:35:06 +0000
+++ doc/en/user-guide/hooks.txt	2010-04-21 07:52:31 +0000
@@ -77,19 +77,32 @@
   Always conflicts if both branches have changed the file.
   """
   
-  from bzrlib.merge import PerFileMerger, Merger
+  from bzrlib.merge import AbstractPerFileMerger, Merger
   
   def merge_xml_files_hook(merger):
       """Hook to merge *.xml files"""
       return MergeXMLFiles(merger)
   
-  class AlwaysConflictXMLMerger(PerFileMerger):
-  
-      def file_matches(self, params):
-          filename = self.get_filename(params, self.merger.this_tree)
-          return filename.endswith('.xml')
-  
-      def merge_matching(self, params):
+  class MergeXMLFiles(AbstractPerFileMerger):
+  
+      def filename_matches(self, params):
+          inventory = self.merger.this_tree.inventory
+          filename = inventory[params.file_id].name
+          if filename.endswith('.xml'):
+              return filename
+  
+      def merge_contents(self, params):
+          """Merge the contents of a single file."""
+          # First, check whether this custom merge logic should be used. We
+          # expect most files should not be merged by this handler.
+          if (
+              # OTHER is a straight winner, rely on default merge.
+              params.winner == 'other' or
+              # THIS and OTHER aren't both files.
+              not params.is_file_merge() or
+              # The filename doesn't match *.xml
+              not self.filename_matches(params)):
+              return 'not_applicable', None
           return 'conflicted', params.this_lines
   
   Merger.hooks.install_named_hook(

